package cn.iocoder.yudao.module.sale.dal.mysql.offer;

import java.util.*;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.sale.dal.dataobject.offer.OfferDO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.sale.vo.offer.*;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;

/**
 * 报价单管理 Mapper
 *
 * @author 系统管理员
 */
@Mapper
public interface OfferMapper extends BaseMapperX<OfferDO> {

    default PageResult<OfferDO> selectPage(OfferPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<OfferDO>()
                .eqIfPresent(OfferDO::getNumber, reqVO.getNumber())
                .eqIfPresent(OfferDO::getOrderId, reqVO.getOrderId())
                .eqIfPresent(OfferDO::getOrderNo, reqVO.getOrderNo())
                .eqIfPresent(OfferDO::getConsignorId, reqVO.getConsignorId())
                .eqIfPresent(OfferDO::getConsigneeId, reqVO.getConsigneeId())
                .eqIfPresent(OfferDO::getMarks, reqVO.getMarks())
                .eqIfPresent(OfferDO::getCustomsType, reqVO.getCustomsType())
                .eqIfPresent(OfferDO::getDepartureId, reqVO.getDepartureId())
                .eqIfPresent(OfferDO::getDeparture, reqVO.getDeparture())
                .eqIfPresent(OfferDO::getObjectiveId, reqVO.getObjectiveId())
                .eqIfPresent(OfferDO::getObjective, reqVO.getObjective())
                .betweenIfPresent(OfferDO::getStopTime, reqVO.getBeginStopTime(), reqVO.getEndStopTime())
                .eqIfPresent(OfferDO::getControl, reqVO.getControl())
                .eqIfPresent(OfferDO::getCompetitor, reqVO.getCompetitor())
                .eqIfPresent(OfferDO::getImportance, reqVO.getImportance())
                .betweenIfPresent(OfferDO::getStartTime, reqVO.getBeginStartTime(), reqVO.getEndStartTime())
                .betweenIfPresent(OfferDO::getEndTime, reqVO.getBeginEndTime(), reqVO.getEndEndTime())
                .eqIfPresent(OfferDO::getTradeType, reqVO.getTradeType())
                .eqIfPresent(OfferDO::getTradeAdress, reqVO.getTradeAdress())
                .eqIfPresent(OfferDO::getRemarks, reqVO.getRemarks())
                .eqIfPresent(OfferDO::getStatus, reqVO.getStatus())
                .eqIfPresent(OfferDO::getOldStatus, reqVO.getOldStatus())
                .eqIfPresent(OfferDO::getRelation, reqVO.getRelation())
                .eqIfPresent(OfferDO::getRelationId, reqVO.getRelationId())
                .eqIfPresent(OfferDO::getCommissionType, reqVO.getCommissionType())
                .eqIfPresent(OfferDO::getWarehousingType, reqVO.getWarehousingType())
                .eqIfPresent(OfferDO::getEstCost, reqVO.getEstCost())
                .eqIfPresent(OfferDO::getSendstatus, reqVO.getSendstatus())
                .betweenIfPresent(OfferDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(OfferDO::getOfferId));
    }

    default List<OfferDO> selectList(OfferExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<OfferDO>()
                .eqIfPresent(OfferDO::getNumber, reqVO.getNumber())
                .eqIfPresent(OfferDO::getOrderId, reqVO.getOrderId())
                .eqIfPresent(OfferDO::getOrderNo, reqVO.getOrderNo())
                .eqIfPresent(OfferDO::getConsignorId, reqVO.getConsignorId())
                .eqIfPresent(OfferDO::getConsigneeId, reqVO.getConsigneeId())
                .eqIfPresent(OfferDO::getMarks, reqVO.getMarks())
                .eqIfPresent(OfferDO::getCustomsType, reqVO.getCustomsType())
                .eqIfPresent(OfferDO::getDepartureId, reqVO.getDepartureId())
                .eqIfPresent(OfferDO::getDeparture, reqVO.getDeparture())
                .eqIfPresent(OfferDO::getObjectiveId, reqVO.getObjectiveId())
                .eqIfPresent(OfferDO::getObjective, reqVO.getObjective())
                .betweenIfPresent(OfferDO::getStopTime, reqVO.getBeginStopTime(), reqVO.getEndStopTime())
                .eqIfPresent(OfferDO::getControl, reqVO.getControl())
                .eqIfPresent(OfferDO::getCompetitor, reqVO.getCompetitor())
                .eqIfPresent(OfferDO::getImportance, reqVO.getImportance())
                .betweenIfPresent(OfferDO::getStartTime, reqVO.getBeginStartTime(), reqVO.getEndStartTime())
                .betweenIfPresent(OfferDO::getEndTime, reqVO.getBeginEndTime(), reqVO.getEndEndTime())
                .eqIfPresent(OfferDO::getTradeType, reqVO.getTradeType())
                .eqIfPresent(OfferDO::getTradeAdress, reqVO.getTradeAdress())
                .eqIfPresent(OfferDO::getRemarks, reqVO.getRemarks())
                .eqIfPresent(OfferDO::getStatus, reqVO.getStatus())
                .eqIfPresent(OfferDO::getOldStatus, reqVO.getOldStatus())
                .eqIfPresent(OfferDO::getRelation, reqVO.getRelation())
                .eqIfPresent(OfferDO::getRelationId, reqVO.getRelationId())
                .eqIfPresent(OfferDO::getCommissionType, reqVO.getCommissionType())
                .eqIfPresent(OfferDO::getWarehousingType, reqVO.getWarehousingType())
                .eqIfPresent(OfferDO::getEstCost, reqVO.getEstCost())
                .eqIfPresent(OfferDO::getSendstatus, reqVO.getSendstatus())
                .betweenIfPresent(OfferDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(OfferDO::getOfferId));
    }


    @ResultType(OfferRespVO.class)
    @Select({
            "<script>",
            "select o.offer_id, ",
            "o.number, ",
            "o.order_no, ",
            "o.order_id, ",
            "if(#{lang} = 0, o.departure ->> '$.titleZh', o.departure ->> '$.titleEn') as departure_name, ",
            "if(#{lang} = 0, o.objective ->> '$.titleZh', o.objective ->> '$.titleEn') as objective_name, ",
            "o.start_time, ",
            "o.end_time, ",
            "o.stop_time, ",
            "o.status, ",
            "o.transport_id, ",
            "o.est_cost, ",
            "o.create_time, ",
            "o.update_time, ",
            "(select count(1) from ecw_customer_follow l where l.biz_id = o.offer_id and l.follow_type = 4) as log_count, ",
            "u.nickname as creator_name, ",
            "(SELECT cc.`name` FROM ecw_customer_contacts cc WHERE ( o.relation = 1 AND cc.id = o.consignor_id ) OR ( o.relation = 2 AND cc.id = o.consignee_id)) AS relation_name ",
            "from ecw_offer o ",
//            "left join ecw_customer_contacts cc on (o.relation = 1 and cc.id = o.consignor_id) or (o.relation = 2 and cc.id = o.consignee_id) ",
            "left join system_user u on u.id = o.follow_up_salesman_id ",
            "where o.deleted = 0",
            "<when test = 'pageVO.deptId != null'>",
            "AND o.dept_id = #{pageVO.deptId} ",
            "</when>",
            "<when test= 'pageVO.deptIdList != null and pageVO.deptIdList.size() > 0'>",
            "AND (o.dept_id IN",
            "<foreach item='deptId' collection='pageVO.deptIdList' open='(' close=')' separator=','> #{deptId} </foreach>",
            " or ",
            "(SELECT u.dept_id FROM system_user u WHERE u.id = o.creator) IN",
            "<foreach item='deptId' collection='pageVO.deptIdList' open='(' close=')' separator=','> #{deptId} </foreach>)",
            "</when>",
            "<when test = 'pageVO.creator != null and pageVO.creator != \"\" '>",
            "AND (o.`salesman_id` = #{pageVO.creator} or o.`creator` = #{pageVO.creator})",
            "</when>",
            "<when test = 'pageVO.status != null'>",
            "AND o.`status` = #{pageVO.status}",
            "</when>",
            "<when test = 'pageVO.transportId != null'>",
            "AND o.`transport_id` = #{pageVO.transportId}",
            "</when>",
            "<when test = 'pageVO.departureId != null'>",
            "AND o.`departure_id` = #{pageVO.departureId}",
            "</when>",
            "<when test = 'pageVO.objectiveId != null'>",
            "AND o.`objective_id` = #{pageVO.objectiveId}",
            "</when>",
            "<when test = 'pageVO.control != null'>",
            "AND o.`control` = #{pageVO.control}",
            "</when>",
            "<when test = 'pageVO.customsType != null'>",
            "AND o.`customs_type` = #{pageVO.customsType}",
            "</when>",
            "<when test = 'pageVO.number != null and pageVO.number != \"\" '>",
            "AND o.`number` like concat('%',concat(#{pageVO.number},'%'))",
            "</when>",
            "<when test = 'pageVO.orderNo != null and pageVO.orderNo != \"\" '>",
            "AND o.`order_no` like concat('%',concat(#{pageVO.orderNo},'%'))",
            "</when>",
            "<when test = 'pageVO.searchNumber != null and pageVO.searchNumber != \"\" '>",
            "AND concat(IFNULL(o.`order_no`,''),  IFNULL(o.`number`,'')) like concat('%',concat(#{pageVO.searchNumber},'%'))",
            "</when>",
            "<when test = 'pageVO.beginCreateTime != null and pageVO.endCreateTime != null '>",
            "AND o.`create_time` between #{pageVO.beginCreateTime} and #{pageVO.endCreateTime}",
            "</when>",
            "<when test = 'pageVO.beginEndTime != null and pageVO.endEndTime != null '>",
            "AND o.`end_time` between #{pageVO.beginEndTime} and #{pageVO.endEndTime}",
            "</when>",
            "<when test = 'pageVO.beginStopTime != null and pageVO.endStopTime != null '>",
            "AND o.`stop_time` between #{pageVO.beginStopTime} and #{pageVO.endStopTime}",
            "</when>",
            "<when test = 'pageVO.prodTitle != null and pageVO.prodTitle != \"\" '>",
            "and (o.offer_id in(",
            "select op.offer_id ",
            "from ecw_offer_prod op ",
            "left join ecw_product_type pt ",
            "on pt.id = op.product_type ",
            "where concat(IFNULL(op.`prod_title_zh`,''),IFNULL(op.`prod_title_en`,''),IFNULL(pt.`title_zh`,''),IFNULL(pt.`title_en`,'')) like concat('%',concat(#{pageVO.prodTitle},'%'))",
            "))",
            "</when>",
            "<when test = 'pageVO.relationId != null'>",
            "AND o.`relation_id` = #{pageVO.relationId}",
            "</when>",
            "<when test = 'pageVO.followUpSalesmanId != null'>",
            "AND o.`follow_up_salesman_id` = #{pageVO.followUpSalesmanId}",
            "</when>",
            "<when test = 'pageVO.searchCustomer != null and pageVO.searchCustomer != \"\" '>",
            "AND o.`relation_id` in(select cc.customer_id from ecw_customer_contacts cc where concat(cc.`name`, cc.phone_new) like concat('%',concat(#{pageVO.searchCustomer},'%')))",
            "</when>",
            " order by o.offer_id DESC ",
            "limit #{pageVO.pageNo}, #{pageVO.pageSize}",
            "</script>"
    })
    List<OfferRespVO> offerPage(@Param("pageVO") OfferPageReqVO pageVO, @Param("lang") Integer lang);

    @ResultType(Long.class)
    @Select({
            "<script>",
            "select count(1)",
            "from ecw_offer o ",
            "left join ecw_customer c on c.id = o.relation_id ",
            "where o.deleted = 0",
            "<when test = 'pageVO.deptId != null'>",
            "AND o.dept_id = #{pageVO.deptId} ",
            "</when>",
            "<when test= 'pageVO.deptIdList != null and pageVO.deptIdList.size() > 0'>",
            "AND (o.dept_id IN",
            "<foreach item='deptId' collection='pageVO.deptIdList' open='(' close=')' separator=','> #{deptId} </foreach>",
            " or ",
            "(SELECT u.dept_id FROM system_user u WHERE u.id = o.creator) IN",
            "<foreach item='deptId' collection='pageVO.deptIdList' open='(' close=')' separator=','> #{deptId} </foreach>)",
            "</when>",
            "<when test = 'pageVO.creator != null and pageVO.creator != \"\" '>",
            "AND (o.`salesman_id` = #{pageVO.creator} or o.`creator` = #{pageVO.creator})",
            "</when>",
            "<when test = 'pageVO.status != null'>",
            "AND o.`status` = #{pageVO.status}",
            "</when>",
            "<when test = 'pageVO.transportId != null'>",
            "AND o.`transport_id` = #{pageVO.transportId}",
            "</when>",
            "<when test = 'pageVO.departureId != null'>",
            "AND o.`departure_id` = #{pageVO.departureId}",
            "</when>",
            "<when test = 'pageVO.objectiveId != null'>",
            "AND o.`objective_id` = #{pageVO.objectiveId}",
            "</when>",
            "<when test = 'pageVO.control != null'>",
            "AND o.`control` = #{pageVO.control}",
            "</when>",
            "<when test = 'pageVO.customsType != null'>",
            "AND o.`customs_type` = #{pageVO.customsType}",
            "</when>",
            "<when test = 'pageVO.number != null and pageVO.number != \"\" '>",
            "AND o.`number` like concat('%',concat(#{pageVO.number},'%'))",
            "</when>",
            "<when test = 'pageVO.orderNo != null and pageVO.orderNo != \"\" '>",
            "AND o.`order_no` like concat('%',concat(#{pageVO.orderNo},'%'))",
            "</when>",
            "<when test = 'pageVO.searchNumber != null and pageVO.searchNumber != \"\" '>",
            "AND concat(IFNULL(o.`order_no`,''),  IFNULL(o.`number`,'')) like concat('%',concat(#{pageVO.searchNumber},'%'))",
            "</when>",
            "<when test = 'pageVO.beginCreateTime != null and pageVO.endCreateTime != null '>",
            "AND o.`create_time` between #{pageVO.beginCreateTime} and #{pageVO.endCreateTime}",
            "</when>",
            "<when test = 'pageVO.beginEndTime != null and pageVO.endEndTime != null '>",
            "AND o.`end_time` between #{pageVO.beginEndTime} and #{pageVO.endEndTime}",
            "</when>",
            "<when test = 'pageVO.beginStopTime != null and pageVO.endStopTime != null '>",
            "AND o.`stop_time` between #{pageVO.beginStopTime} and #{pageVO.endStopTime}",
            "</when>",
            "<when test = 'pageVO.relationId != null'>",
            "AND o.`relation_id` = #{pageVO.relationId}",
            "</when>",
            "<when test = 'pageVO.followUpSalesmanId != null'>",
            "AND o.`follow_up_salesman_id` = #{pageVO.followUpSalesmanId}",
            "</when>",
            "<when test = 'pageVO.prodTitle != null and pageVO.prodTitle != \"\" '>",
            "and (o.offer_id in(",
            "select op.offer_id ",
            "from ecw_offer_prod op ",
            "left join ecw_product_type pt ",
            "on pt.id = op.product_type ",
            "where concat(IFNULL(op.`prod_title_zh`,''),IFNULL(op.`prod_title_en`,''),IFNULL(pt.`title_zh`,''),IFNULL(pt.`title_en`,'')) like concat('%',concat(#{pageVO.prodTitle},'%'))",
            "))",
            "</when>",
            "<when test = 'pageVO.relationId != null'>",
            "AND o.`relation_id` = #{pageVO.relationId}",
            "</when>",
            "<when test = 'pageVO.searchCustomer != null and pageVO.searchCustomer != \"\" '>",
            "AND o.`relation_id` in(select cc.customer_id from ecw_customer_contacts cc where concat(cc.`name`, cc.phone_new) like concat('%',concat(#{pageVO.searchCustomer},'%')))",
            "</when>",
            "</script>"
    })
    Long countOfferList(@Param("pageVO") OfferPageReqVO pageVO);


    @ResultType(OfferRespVO.class)
    @Select({
            "<script>",
            "select o.offer_id, ",
            "o.number, ",
            "o.order_no, ",
            "o.order_id, ",
            "if(#{lang} = 0, o.departure ->> '$.titleZh', o.departure ->> '$.titleEn') as departure_name, ",
            "if(#{lang} = 0, o.objective ->> '$.titleZh', o.objective ->> '$.titleEn') as objective_name, ",
            "o.start_time, ",
            "o.end_time, ",
            "o.stop_time, ",
            "o.status, ",
            "o.transport_id, ",
            "o.est_cost, ",
            "o.create_time, ",
            "o.update_time, ",
            "(select count(1) from ecw_customer_follow l where l.biz_id = o.offer_id and l.follow_type = 4) as log_count, ",
            "u.nickname as creator_name, ",
            "cc.name as relation_name",
            "from ecw_offer o ",
            "left join ecw_customer_contacts cc on (o.relation = 1 and cc.id = o.consignor_id) or (o.relation = 2 and cc.id = o.consignee_id) ",
            "left join system_user u on u.id = o.follow_up_salesman_id ",
            "where o.deleted = 0",
            "AND o.`status` in(1,3,4,5,6)",
            "AND (o.`order_id` is null or o.`order_id` = 0)",
            "AND o.`end_time` > now()",
            "AND (o.`consignor_id` = #{queryVO.consignorId}",
            "<when test = 'queryVO.consigneeId != null'>",
            "or o.`consignee_id` = #{queryVO.consigneeId}",
            "</when>",
            ")",
            "<when test = 'queryVO.lineId != null'>",
            "AND o.`line_id` = #{queryVO.lineId}",
            "</when>",
            "<when test = 'queryVO.channelId != null'>",
            "AND o.`channel_id` = #{queryVO.channelId}",
            "</when>",
            " order by o.offer_id DESC ",
            "</script>"
    })
    List<OfferRespVO> getOrderAssociationOfferList(@Param("queryVO") OrderAssociationOfferQueryVO queryVO, @Param("lang") Integer lang);
}
