package cn.iocoder.yudao.module.sale.enums;

import cn.iocoder.yudao.framework.common.exception.ErrorCode;

/**
 * Member 错误码枚举类
 *
 * member 系统，使用 1-004-000-000 段
 */
public interface ErrorCodeConstants {
    ErrorCode PROD_LINE_PRICE_NOT_SET = new ErrorCode(1004010001, "prod.line.price.not.set");
    ErrorCode UNIT_NOT_LEGAL = new ErrorCode(1004010002, "unit.not.legal");
    ErrorCode OFFER_NOT_EXISTS = new ErrorCode(1004010003, "offer.not.exists");
    ErrorCode VOLUME_UNIT_NOT_NULL = new ErrorCode(1004010004, "volume.unit.not.null");
    ErrorCode WEIGHT_UNIT_NOT_NULL = new ErrorCode(1004010005, "weight.unit.not.null");
    ErrorCode THIS_LINE_PROD_NOT_SET_LICENSED_PRICE = new ErrorCode(1004010006, "line.prod.not.set.licensed.price");
    ErrorCode WAREHOUSING_TYPE_NOT_NULL = new ErrorCode(1004010007, "warehousing.type.not.null");
    ErrorCode OFFER_SPECIAL_APPLY_SEA_FREIGHT_ERROR = new ErrorCode(1004010008, "offer.special.apply.sea.freight.error");
    ErrorCode OFFER_SPECIAL_APPLY_CLEARANCE_FREIGHT_ERROR = new ErrorCode(1004010009, "offer.special.apply.clearance.freight.error");
    ErrorCode PROD_ID_NOT_NULL = new ErrorCode(1004010010, "prod.id.not.null");
    ErrorCode DEPARTURE_NOT_EXISTS = new ErrorCode(1004010011, "departure.not.exists");
    ErrorCode OBJECTIVE_NOT_EXISTS = new ErrorCode(1004010012, "objective.not.exists");
    ErrorCode THIS_LINE_PROD_ON_BLACK_LIST = new ErrorCode(1004010013, "this.line.prod.on.black.list");
    ErrorCode PROD_NOT_EXISTS = new ErrorCode(1004010014, "prod.not.exists");
    ErrorCode CITY_NOT_SET_LABEL_CODE = new ErrorCode(1004010015, "city.not.set.label.code");
    ErrorCode OFFER_IS_END = new ErrorCode(1004010016, "offer.is.end");
    ErrorCode OFFER_PROD_NOT_NULL = new ErrorCode(1004010017, "offer.prod.not.null");
    ErrorCode OFFER_START_END_TIME_NOT_NULL = new ErrorCode(1004010018, "offer.start.end.time.not.null");
    ErrorCode CUSTOMER_CONTACTS_NOT_EXISTS = new ErrorCode(1004010019, "customer.contacts.not.exists");
    ErrorCode TRANSPORT_NOT_NULL = new ErrorCode(1004010020, "transport.not.null");
    ErrorCode OFFER_SPECIAL_APPLY_FORM_DETAILS_NOT_EXISTS = new ErrorCode(1004010021, "offer.special.apply.form.details.not.exists");
    ErrorCode OFFER_SPECIAL_APPLY_FORM_APPROVAL_FINISH = new ErrorCode(1004010022, "offer.special.apply.form.approval.finish");
    ErrorCode OFFER_CHANNEL_SET_ERROR = new ErrorCode(1004010023, "offer.channel.set.error");
    ErrorCode OFFER_CONSIGNOR_ERROR = new ErrorCode(1004010024, "offer.consignor.error");
    ErrorCode OFFER_CONSIGNEE_ERROR = new ErrorCode(1004010025, "offer.consignee.error");
    ErrorCode OFFER_PROD_APPROVAL_IN_PROGRESS = new ErrorCode(1004010026, "offer.prod.approval.in.progress");
    ErrorCode OFFER_TRANSPORT_NOT_EXISTS = new ErrorCode(1004010027, "offer.transport.not.exists");
    ErrorCode DEPT_TARGET_NOT_EXISTS = new ErrorCode(1004010028, "dept.target.not.exist");
    ErrorCode ORDER_NOT_FIND = new ErrorCode(1004010029, "赢单关联订单未找到");
    ErrorCode ORDER_CREATE_FAIL = new ErrorCode(1004010030, "赢单创建订单失败");
    ErrorCode OFFER_STATUS_ERROR = new ErrorCode(1004010031, "报价单状态错误");
    ErrorCode OFFER_COMMISSION_TYPE_NOT_NULL = new ErrorCode(1004010032, "报价单佣金设置申请时佣金类型不能为空");
    ErrorCode OFFER_LIGHT_COMMISSION_NOT_NULL = new ErrorCode(1004010033, "报价单佣金设置申请时明佣金额不能为空");
    ErrorCode OFFER_SGADE_COMMISSION_NOT_NULL = new ErrorCode(1004010034, "报价单佣金设置申请时暗佣金额不能为空");
    ErrorCode OFFER_LIGHT_SGADE_COMMISSION_NOT_NULL = new ErrorCode(1004010035, "报价单佣金设置申请时明佣和暗佣金额不能为空");
    ErrorCode OFFER_APPROVAL_STATUS_NOT_CORRECT = new ErrorCode(1004010036, "报价单特价审批的状态类型不正确");
    ErrorCode OFFER_APPROVAL_FORM_ID_NOT_EXISTS = new ErrorCode(1004010037, "报价单特价审批的流程实例ID不存在");
    ErrorCode OFFER_APPROVAL_NOT_EXISTS = new ErrorCode(1004010038, "报价单特价审批不存在");
    ErrorCode RECOVERY_CANCEL_OFFER_STATUS_ERROR = new ErrorCode(1004010039, "恢复取消的报价单状态错误");
    ErrorCode RECOVERY_CANCEL_OFFER_TIME_EXPIRE = new ErrorCode(1004010040, "恢复取消的报价单有效期已过期");
    ErrorCode OFFER_FOLLOW_UP_STATUS_ERROR = new ErrorCode(1004010041, "报价单跟进记录添加只能在报价单是确认与跟进中时添加");
    ErrorCode OFFER_ASCRIPTION_CONSIGNOR_NOT_NULL = new ErrorCode(1004010042, "报价单归属发货人不能为空");
    ErrorCode OFFER_ASCRIPTION_CONSIGNEE_NOT_NULL = new ErrorCode(1004010043, "报价单归属收货人不能为空");
    ErrorCode OFFER_ID_NOT_NULL = new ErrorCode(1004010044, "报价单ID不能为空");
    ErrorCode OFFER_SPECIAL_APPLY_SEA_FREIGHT_NOT_NULL = new ErrorCode(1004010045, "特价申请的运费单价不能为空");
    ErrorCode OFFER_SPECIAL_APPLY_CLEARANCE_FREIGHT_NOT_NULL = new ErrorCode(1004010046, "特价申请的清关费单价不能为空");
    ErrorCode OFFER_PROD_SPECIAL_APPLY_NO_MULTIPLE_PROGRESS = new ErrorCode(1004010047,"报价单商品的特价申请不能多个同时进行");
    ErrorCode OFFER_CONTAIN_NOT_ACCEPTED_PROD = new ErrorCode(1004010048,"offer.contain.not.accepted.prod");

    ErrorCode CHANNEL_PRICE_STEP_CLEARANCE_NOT_EXISTS = new ErrorCode(1004010049, "渠道清关费阶梯价格不存在");

    ErrorCode CHANNEL_PACKAGING_TYPE_REPEAT = new ErrorCode(1004010050, "channel.packaging.type.repeat");

    ErrorCode CHANNEL_PACKAGING_NOT_EXISTS = new ErrorCode(1004010051, "渠道清关费包装类型不存在");
    ErrorCode ORDER_ASSOCIATION_OFFER_NO_CAN_UPDATE = new ErrorCode(1004010052, "order.association.offer.no.can.update");
    ErrorCode ORDER_BOUND_OFFER = new ErrorCode(1004010053, "order.bound.offer");


}
