package cn.iocoder.yudao.module.sale.service.offer.impl;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.code.CodeUtils;
import cn.iocoder.yudao.framework.common.util.validation.StrValidationUtils;
import cn.iocoder.yudao.framework.dict.core.dto.DictDataRespDTO;
import cn.iocoder.yudao.framework.i18n.core.I18nMessage;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.framework.mybatis.core.util.MyBatisUtils;
import cn.iocoder.yudao.framework.security.core.LoginUser;
import cn.iocoder.yudao.framework.security.core.util.SecurityFrameworkUtils;
import cn.iocoder.yudao.module.bpm.enums.WorkFlowEmus;
import cn.iocoder.yudao.module.bpm.api.BpmCreateServiceFactory;
import cn.iocoder.yudao.module.depository.dal.dataobject.warehouse.WarehouseLineDO;
import cn.iocoder.yudao.module.depository.dal.mysql.warehouse.WarehouseLineMapper;
import cn.iocoder.yudao.module.customer.vo.zhongPao.CustomerZhongPaoQueryVO;
import cn.iocoder.yudao.module.customer.vo.zhongPao.ZhongPaoBestVO;
import cn.iocoder.yudao.module.depository.dto.LogisticsInfoDto;
import cn.iocoder.yudao.module.ecw.api.customer.CustomerApi;
import cn.iocoder.yudao.module.ecw.dal.dataobject.currency.CurrencyDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.CustomerDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerContacts.CustomerContactsDO;
import cn.iocoder.yudao.module.ecw.service.currency.CurrencyService;
import cn.iocoder.yudao.module.customer.service.zhongPao.ZhongPaoService;
import cn.iocoder.yudao.module.member.api.user.MemberUserApi;
import cn.iocoder.yudao.module.member.api.user.dto.UserRespDTO;
import cn.iocoder.yudao.module.order.dal.dataobject.order.OrderDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderConsignee.OrderConsigneeDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderConsignor.OrderConsignorDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderNumberLog.OrderNumberLogDO;
import cn.iocoder.yudao.module.order.enums.OrderNumberEnum;
import cn.iocoder.yudao.module.order.enums.OrderStatusEnum;
import cn.iocoder.yudao.module.order.service.order.OrderConsigneeService;
import cn.iocoder.yudao.module.order.service.order.OrderConsignorService;
import cn.iocoder.yudao.module.order.service.orderNumberLog.OrderNumberLogService;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductAttrDO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductDO;
import cn.iocoder.yudao.module.ecw.dal.dataobject.region.RegionDO;
import cn.iocoder.yudao.module.product.dto.CouponAvailableGroupDto;
import cn.iocoder.yudao.module.product.dto.FeeDto;
import cn.iocoder.yudao.module.product.enums.FeeTypeEnum;
import cn.iocoder.yudao.module.customer.service.customer.CustomerService;
import cn.iocoder.yudao.module.customer.service.customerContacts.CustomerContactsService;
import cn.iocoder.yudao.module.ecw.service.region.RegionService;
import cn.iocoder.yudao.module.order.service.order.OrderService;
import cn.iocoder.yudao.module.order.vo.order.OrderCreateReqVO;
import cn.iocoder.yudao.module.order.vo.orderItem.OrderItemCreateReqVO;
import cn.iocoder.yudao.module.product.component.ProdCostCalculation;
import cn.iocoder.yudao.module.product.dto.CalculationCostResultDto;
import cn.iocoder.yudao.module.product.dto.ProdCostDto;
import cn.iocoder.yudao.module.product.param.ProdConditionParam;
import cn.iocoder.yudao.module.product.service.product.ProductService;
import cn.iocoder.yudao.module.sale.convert.offer.OfferConvert;
import cn.iocoder.yudao.module.sale.convert.offer.OfferProdConvert;
import cn.iocoder.yudao.module.sale.convert.offer.OfferTransportConvert;
import cn.iocoder.yudao.module.sale.convert.offerApproval.OfferApprovalConvert;
import cn.iocoder.yudao.module.sale.dal.dataobject.offer.OfferDO;
import cn.iocoder.yudao.module.sale.dal.dataobject.offer.OfferLogDO;
import cn.iocoder.yudao.module.sale.dal.dataobject.offer.OfferProdDO;
import cn.iocoder.yudao.module.sale.dal.dataobject.offer.OfferTransportDO;
import cn.iocoder.yudao.module.sale.dal.dataobject.offerApproval.OfferApprovalDO;
import cn.iocoder.yudao.module.sale.dal.mysql.offer.OfferMapper;
import cn.iocoder.yudao.module.sale.dal.mysql.offer.OfferProdMapper;
import cn.iocoder.yudao.module.sale.dal.mysql.offer.OfferTransportMapper;
import cn.iocoder.yudao.module.sale.dal.mysql.offerApproval.OfferApprovalMapper;
import cn.iocoder.yudao.module.sale.dto.CalculationProdFeeDto;
import cn.iocoder.yudao.module.sale.service.offer.OfferLogService;
import cn.iocoder.yudao.module.sale.service.offer.OfferService;
import cn.iocoder.yudao.module.sale.vo.offer.*;
import cn.iocoder.yudao.module.sale.vo.offerApproval.OfferApprovalBackInfoVO;
import cn.iocoder.yudao.module.sale.vo.offerApproval.OfferApprovalBackVO;
import cn.iocoder.yudao.module.system.api.dict.DictDataApi;
import cn.iocoder.yudao.module.system.api.user.AdminUserApi;
import cn.iocoder.yudao.module.system.api.user.dto.AdminUserRespDTO;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import lombok.AllArgsConstructor;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;
import java.net.URLEncoder;
import java.text.MessageFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.order.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.module.product.enums.ErrorCodeConstants.NOT_FIND_CURRENCY;
import static cn.iocoder.yudao.module.sale.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.module.sale.enums.ErrorCodeConstants.DEPARTURE_NOT_EXISTS;
import static cn.iocoder.yudao.module.sale.enums.ErrorCodeConstants.OBJECTIVE_NOT_EXISTS;
import static cn.iocoder.yudao.module.sale.enums.ErrorCodeConstants.PROD_NOT_EXISTS;

/**
 * 报价单管理 Service 实现类
 *
 * @author 系统管理员
 */
@Service
@Validated
@AllArgsConstructor
public class OfferServiceImpl extends AbstractService<OfferMapper, OfferDO> implements OfferService {

    private final OfferMapper offerMapper;
    private final OfferTransportMapper offerTransportMapper;
    private final OfferProdMapper offerProdMapper;
    private final OfferApprovalMapper offerApprovalMapper;
    private final ProductService productService;
    private final RegionService regionService;
    private final OfferLogService offerLogService;
    private final BpmCreateServiceFactory bpmCreateServiceFactory;
    private final OrderService orderService;
    private final MemberUserApi memberUserApi;
    private final CustomerApi customerApi;
    private final OrderConsignorService orderConsignorService;
    private final OrderConsigneeService orderConsigneeService;
    private final CustomerContactsService customerContactsService;
    private final CustomerService customerService;
    private final AdminUserApi adminUserApi;
    private final ProdCostCalculation prodCostCalculation;
    private final OrderNumberLogService orderNumberLogService;
    private final CurrencyService currencyService;
    private final DictDataApi dictDataApi;
    private final WarehouseLineMapper warehouseLineMapper;
    private final ZhongPaoService zhongPaoService;

    /**
     * 最新报价单号缓存
     */
    private static final String OFFER_NEW_NUMBER = "offer:new:number:{0}";

    private static final String DATA_FORMAT = "yyyy-MM-dd-HH-mm-ss";

    private static final String CHARACTER_UTF_8 = "UTF-8";

    private static final String CONTENT_TYPE = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet";
    private static final String CONTENT_DISPOSITION = "Content-Disposition";

    private static final String CACHE_CONTROL = "Cache-Control";

    private static final String NO_STORE = "no-store";

    private static final String MAX_AGE = "max-age=0";

    private static final Integer PAGE_SIZE = 10000;


    @Override
    @Transactional(rollbackFor = Exception.class)
    public Long createOffer(OfferCreateReqVO createReqVO) {
        if (null == createReqVO.getStartTime() || null == createReqVO.getEndTime()) {
            throw exception(OFFER_START_END_TIME_NOT_NULL);
        }
        if (StringUtils.isNotBlank(createReqVO.getMarks())) {
            // 如果报价单唛头不为空，已校验过格式，需要对长度进行再校验
            if (createReqVO.getMarks().length() > 20) {
                throw exception(MARKS_LENGTH_MAX, 20);
            }
        }
        if (createReqVO.getRelation() == 1 && (Objects.isNull(createReqVO.getConsignorId()) || createReqVO.getConsignorId() == 0)) {
            throw exception(OFFER_ASCRIPTION_CONSIGNOR_NOT_NULL);
        }
        if (createReqVO.getRelation() == 2 && (Objects.isNull(createReqVO.getConsigneeId()) || createReqVO.getConsigneeId() == 0)) {
            throw exception(OFFER_ASCRIPTION_CONSIGNEE_NOT_NULL);
        }
        if (StringUtils.isNotBlank(createReqVO.getMarks())) {
            if (!StrValidationUtils.isIndexLetterAndLetterDigit(createReqVO.getMarks()) && createReqVO.getMarks().length() > 15) {
                throw exception(MARKS_FORMAT_INCORRECT);
            }
        }
        if (Objects.nonNull(createReqVO.getConsigneeId()) && createReqVO.getConsigneeId() > 0) {
            if (Objects.isNull(createReqVO.getControl()) || !createReqVO.getControl()) {
                // 获取功能开关
                List<DictDataRespDTO> dictList = dictDataApi.getDictDatas("part_function_switch");
                // 智慧预装功能开关
                DictDataRespDTO dictDataRespDTO = dictList.stream().filter(dto -> "create_order_phone_limit".equals(dto.getLabel())).findFirst().orElse(null);
                CustomerContactsDO consigneeContactsDO = customerContactsService.getCustomerContacts(createReqVO.getConsigneeId());
                if (Objects.nonNull(consigneeContactsDO)) {
                    if (Objects.nonNull(dictDataRespDTO) && StringUtils.equals(dictDataRespDTO.getValue(), "11") && StringUtils.isNotBlank(consigneeContactsDO.getAreaCode()) && StringUtils.equals("86", consigneeContactsDO.getAreaCode())) {
                        throw exception(CONSIGNEE_PHONE_IS_EXTERNAL);
                    }
                }
            }
        }

        OfferTransportDO offerTransportDO = OfferTransportConvert.INSTANCE.convert(createReqVO.getTransportVO());
        List<OfferProdDO> offerProdDOList = createReqVO.getProdCreateReqVOList().stream().map(OfferProdConvert.INSTANCE::convert).collect(Collectors.toList());
        // 插入报价单
        OfferDO offer = OfferConvert.INSTANCE.convert(createReqVO);
        if (Objects.nonNull(createReqVO.getEstCostVO())) {
            offer.setEstCost(JSONObject.toJSONString(createReqVO.getEstCostVO()));
        }
//        offer.setStatus(2);// 确认中
        // 查询始发地与目的地信息
        RegionDO departure = regionService.getRegion(offer.getDepartureId());
        if (Objects.isNull(departure) || (!StrUtil.equals(departure.getType(), "2") && !StrUtil.equals(departure.getType(), "3"))) {
            throw exception(DEPARTURE_NOT_EXISTS);
        }
        RegionDO objective = regionService.getRegion(offer.getObjectiveId());
        if (Objects.isNull(objective) || (!StrUtil.equals(objective.getType(), "1") && !StrUtil.equals(objective.getType(), "3"))) {
            throw exception(OBJECTIVE_NOT_EXISTS);
        }
        offer.setDeparture(JSONObject.toJSONString(departure));
        offer.setObjective(JSONObject.toJSONString(objective));
        // 报价单关联客户信息保存
        CustomerContactsDO customerContactsDO = customerContactsService.getCustomerContacts(offer.getRelation() == 1 ? offer.getConsignorId() : offer.getConsigneeId());
        if (Objects.isNull(customerContactsDO)) {
            throw exception(CUSTOMER_CONTACTS_NOT_EXISTS);
        }
        offer.setRelationId(customerContactsDO.getCustomerId());

        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        String creator = String.valueOf(loginUser != null ? loginUser.getId() : null);
        String name = loginUser != null ? loginUser.getUsername() : "null";
        offer.setCreator(creator);
        offer.setUpdater(creator);
        if (Objects.nonNull(customerContactsDO.getCustomerId())) {
            CustomerDO customerDO = customerService.getById(customerContactsDO.getCustomerId());
            if (Objects.nonNull(customerDO) && Objects.nonNull(customerDO.getCustomerService())) {
                offer.setFollowUpSalesmanId(String.valueOf(customerDO.getCustomerService()));
                offer.setSalesmanId(customerDO.getCustomerService());
                AdminUserRespDTO adminUserRespDTO = adminUserApi.getUser(customerDO.getCustomerService());
                if (Objects.nonNull(adminUserRespDTO)) {
                    offer.setDeptId(adminUserRespDTO.getDeptId());
                }
            }
        }
        if (StringUtils.isBlank(offer.getFollowUpSalesmanId())) {
            offer.setFollowUpSalesmanId(creator);
        }

        // 报价单号生成
        String key = MessageFormat.format(OFFER_NEW_NUMBER, name);
        // 订单号生成
        OrderNumberLogDO orderNumberLogDO = orderNumberLogService.newNumberInfo(key, OrderNumberEnum.OFFER_NO.getType());
        String number = Objects.isNull(orderNumberLogDO) ? null : orderNumberLogDO.getNumber();
        String newNumber = CodeUtils.getOddOfferNumbers(number, name);
        offer.setNumber(newNumber);
        offerMapper.insert(offer);
        offerTransportDO.setOfferId(offer.getOfferId());
        offerTransportDO.setTransportId(offer.getTransportId());
        offerTransportDO.setLineIds(String.valueOf(offer.getLineId()));
        offerTransportDO.setChannelIds(String.valueOf(offer.getChannelId()));
        offerTransportMapper.insert(offerTransportDO);
        // 更新最新报价单
        orderNumberLogService.saveOrUpdateNewNumber(orderNumberLogDO, key, OrderNumberEnum.OFFER_NO.getType(), newNumber);
        this.costCalculation(creator, offer, offerProdDOList, 1, null);

        this.addOfferLog(offer.getOfferId(), offer.getNumber(), offer.getRelationId(), 1, creator, "新建报价成功");

        //报价成功就接收那些待接收的客户
        customerService.receiveCustomer(offer.getRelationId(), loginUser.getId());

        //20230302 新需求 报价创建后 就更新线索客户到意向
        // TODO offer.getConsigneeId(), offer.getConsignorId()这两个是客户联系人ID offer.getRelationId()这个才是关联客户id 后面确定下是否将另一个客户也添加日志信息
//        Set<Long> idSet = Stream.of(offer.getConsigneeId(), offer.getConsignorId(), offer.getRelationId()).filter(Objects::nonNull).collect(Collectors.toSet());
        Set<Long> idSet = Stream.of(offer.getRelationId()).filter(Objects::nonNull).collect(Collectors.toSet());
        for (Long id : idSet) {
            customerService.updateCustomerByCreateOffer(id, offer.getCreateTime());
        }
        // 返回
        return offer.getOfferId();
    }

    /**
     * 报价单操作日志添加
     *
     * @param offerId        报价单ID
     * @param number         报价单号
     * @param customerId     客户ID
     * @param followUpMethod 方式 1：新建报价 2 修改报价 3特价申请 4电话 5网络 6报价结束
     * @param userId         操作用户ID(业务员ID)
     * @param result         处理结果说明
     */
    public void addOfferLog(Long offerId, String number, Long customerId, Integer followUpMethod, String userId, String result) {
        String contacts = "";
        if (null != customerId) {
            // TODO 查询客户信息
        }
        OfferLogDO offerLogDO = new OfferLogDO();
        offerLogDO.setOfferId(offerId);
        offerLogDO.setNumber(number);
        offerLogDO.setContacts(contacts);
        offerLogDO.setType(1); // 操作日志
        offerLogDO.setFollowUpTime(new Date());
        offerLogDO.setFollowUpSalesmanId(userId);
        offerLogDO.setFollowUpMethod(followUpMethod);
        offerLogDO.setCreator(userId);
        offerLogDO.setProcessingResults(result);
        offerLogDO.setCreateTime(new Date());
        offerLogService.save(offerLogDO);
    }


    /**
     * 计算单种运输方式的商品费用，并批量插入
     *
     * @param offerProdDOList 商品列表
     * @param offer           报价单主体
     * @param type            类型 ： 1 新增 2 修改 3 特价申请 4 计算
     * @param specialApplyVO  特价申请的商品新基础运费信息
     * @return 该运输方式下的报价商品列表信息
     */
    private CalculationProdFeeDto insertOfferProdDOList(List<OfferProdDO> offerProdDOList, OfferDO offer, ZhongPaoBestVO zhongPaoBestVO,
                                                        Integer type, OfferSpecialApplyVO specialApplyVO) {
        if (CollectionUtil.isEmpty(offerProdDOList)) {
            throw exception(OFFER_IS_END);
        }
        List<OfferProdDO> newProdDOList = new ArrayList<>();

        List<ProdConditionParam> prodConditionParamList = offerProdDOList.stream().map(offerProdDO -> {
            ProductDO productDO = productService.info(offerProdDO.getProdId());
            if (productDO == null) {
                throw exception(PROD_NOT_EXISTS);
            }
            if (CollectionUtil.isNotEmpty(productDO.getAttrList())) {
                long count = productDO.getAttrList().stream().map(ProductAttrDO::getAttrCode).filter(code -> StringUtils.equals(code, "F")).count();
                if (count > 0) {
                    // 报价单包含不接受货物，请检查
                    throw exception(OFFER_CONTAIN_NOT_ACCEPTED_PROD);
                }
            }
            offerProdDO.setProdTitleEn(productDO.getTitleEn());
            offerProdDO.setProdTitleZh(productDO.getTitleZh());
            offerProdDO.setProductType(Objects.isNull(productDO.getTypeId()) ? null : Math.toIntExact(productDO.getTypeId()));
            offerProdDO.setOfferId(offer.getOfferId());
            offerProdDO.setTransportId(offer.getTransportId());
            offerProdDO.setChannelId(offer.getChannelId());
            offerProdDO.setLineId(offer.getLineId());
            if (null == offerProdDO.getOfferProdId()) {
                offerProdMapper.insert(offerProdDO);
            }
            ProdConditionParam param = new ProdConditionParam();
            param.setCustomsType(offer.getCustomsType());
            param.setItemId(offerProdDO.getOfferProdId());
            // 特价优惠申请通过后,则标识已定价
            param.setIsPriced(Objects.nonNull(offerProdDO.getSpecialPriceType()) && offerProdDO.getSpecialPriceType());
            // 已设置佣金特价
            param.setSpecialCommission(Objects.nonNull(offerProdDO.getSpecialCommission()) && offerProdDO.getSpecialCommission());
            param.setCommissionType(offerProdDO.getCommissionType());
            param.setHiddenCommission(offerProdDO.getHiddenCommission());
            param.setPlainCommission(offerProdDO.getPlainCommission());
            if (StringUtils.isNotBlank(offerProdDO.getCouponInfo())) {
                param.setGroupDto(JSONObject.parseObject(offerProdDO.getCouponInfo(), CouponAvailableGroupDto.class));
            }
            param.setMinMeteringQuantity(offerProdDO.getMinMeteringQuantity());
            param.setMinMeteringVolume(offerProdDO.getMinMeteringVolume());
            param.setMinMeteringWeight(offerProdDO.getMinMeteringWeight());


            param.setOneSeaFreight(offerProdDO.getOneSeaFreight());
            param.setFreightCurrency(Objects.isNull(offerProdDO.getSeaFreightCurrency()) ? null : Integer.valueOf(String.valueOf(offerProdDO.getSeaFreightCurrency())));
            param.setFreightVolume(offerProdDO.getSeaFreightVolume());
            param.setOneClearanceFee(offerProdDO.getOneClearanceFreight());
            param.setClearanceFeeCurrency(Objects.isNull(offerProdDO.getClearanceFreightCurrency()) ? null : Integer.valueOf(String.valueOf(offerProdDO.getClearanceFreightCurrency())));
            param.setClearanceFeeVolume(offerProdDO.getClearanceFreightVolume());

            param.setLiquidFreightPrice(offerProdDO.getLiquidFreightPrice());
            param.setLiquidClearanceFeePrice(offerProdDO.getLiquidClearanceFeePrice());
            param.setElectrifiedFreightPrice(offerProdDO.getElectrifiedFreightPrice());
            param.setElectrifiedClearanceFeePrice(offerProdDO.getElectrifiedClearanceFeePrice());
            param.setBrandFreightPrice(offerProdDO.getBrandFreightPrice());
            param.setBrandClearanceFeePrice(offerProdDO.getBrandClearanceFeePrice());
            param.setPackagingFreightPrice(offerProdDO.getPackagingFreightPrice());
            param.setPackagingClearanceFeePrice(offerProdDO.getPackagingClearanceFeePrice());
            param.setDiscountFreightPrice(offerProdDO.getDiscountFreightPrice());
            param.setDiscountFreightTotalPrice(offerProdDO.getDiscountFreightTotalPrice());
            param.setDiscountClearanceFeePrice(offerProdDO.getDiscountClearanceFeePrice());
            param.setDiscountClearanceFeeTotalPrice(offerProdDO.getDiscountClearanceFeeTotalPrice());

            param.setVWeight(offerProdDO.getVolume().multiply(zhongPaoBestVO.getPaoFormulas()));
            param.setWVolume(offerProdDO.getWeight().multiply(zhongPaoBestVO.getZhongFormulas()));
            param.setProdId(offerProdDO.getProdId());
            param.setProdAttrIds(offerProdDO.getProdAttrIds());
            param.setTransportId(offer.getTransportId());
            param.setChannelId(offer.getChannelId());
            param.setLineId(offer.getLineId());
            param.setPackages(Collections.singletonList(offerProdDO.getUnit()));
            param.setProdTitleEn(productDO.getTitleEn());
            param.setProdTitleZh(productDO.getTitleZh());
            param.setProductType(Objects.isNull(productDO.getTypeId()) ? null : Math.toIntExact(productDO.getTypeId()));
            param.setCharging(offerProdDO.getCharging());
            param.setIsPayAdvance(offerProdDO.getIsPayAdvance());
            param.setQuantity(offerProdDO.getQuantity());
            param.setNum(offerProdDO.getNum());
            param.setVolume(offerProdDO.getVolume());
            param.setWeight(offerProdDO.getWeight());
            param.setWorth(offerProdDO.getWorth());
            param.setBoxGauge(offerProdDO.getBoxGauge());
            param.setBrandType(offerProdDO.getBrand());
            return param;
        }).collect(Collectors.toList());
        List<ProdConditionParam> prodConditionParams = prodCostCalculation.obtainProdLineOnePrice(prodConditionParamList, offer.getNumber(), offer.getCustomsType(),
                offer.getRelationId(), offer.getTransportId(), offer.getLineId(), offer.getChannelId(), false);
        CalculationCostResultDto resultDto = prodCostCalculation.calculationProdCost(prodConditionParams, offer.getNumber(), 1, offer.getCustomsType(),
                0, null, offer.getRelationId(), null, null, offer.getConsignorId(), offer.getConsigneeId(),
                offer.getTransportId(), offer.getLineId(), offer.getChannelId());
        for (OfferProdDO offerProdDO : offerProdDOList) {
            Integer status = 0;
            for (ProdCostDto prodCostDto : resultDto.getProdCostDtoList()) {
                if (Objects.equals(prodCostDto.getItemId(), offerProdDO.getOfferProdId())) {
                    if (prodCostDto.getClearanceFee().compareTo(BigDecimal.ZERO) == 0 && prodCostDto.getFreight().compareTo(BigDecimal.ZERO) == 0) {
                        offerProdDO.setStatus(-1);// 未设置价格
                    }
                    if (Objects.nonNull(prodCostDto.getGroupDto())) {
                        offerProdDO.setCouponInfo(JSONObject.toJSONString(prodCostDto.getGroupDto()));
                    }
                    if (Objects.isNull(offerProdDO.getSpecialCommission()) || !offerProdDO.getSpecialCommission()) {
                        offerProdDO.setCommissionType(prodCostDto.getCommissionType());
                        offerProdDO.setPlainCommission(prodCostDto.getPlainCommission());
                        offerProdDO.setHiddenCommission(prodCostDto.getHiddenCommission());
                    }
                    offerProdDO.setMinMeteringQuantity(prodCostDto.getMinMeteringQuantity());
                    offerProdDO.setMinMeteringVolume(prodCostDto.getMinMeteringVolume());
                    offerProdDO.setMinMeteringWeight(prodCostDto.getMinMeteringWeight());

                    offerProdDO.setOneClearanceFreight(prodCostDto.getOneClearanceFee());
                    offerProdDO.setClearanceFreight(prodCostDto.getClearanceFee());
                    offerProdDO.setOriginalClearanceFreight(prodCostDto.getOrgClearanceFeePrice());
                    offerProdDO.setClearanceFreightVolume(prodCostDto.getClearanceFeeVolume());
                    offerProdDO.setClearanceFreightCurrency(prodCostDto.getClearanceFeeCurrency());

                    offerProdDO.setLiquidFreightPrice(prodCostDto.getLiquidFreightPrice());
                    offerProdDO.setLiquidClearanceFeePrice(prodCostDto.getLiquidClearanceFeePrice());
                    offerProdDO.setElectrifiedFreightPrice(prodCostDto.getElectrifiedFreightPrice());
                    offerProdDO.setElectrifiedClearanceFeePrice(prodCostDto.getElectrifiedClearanceFeePrice());
                    offerProdDO.setBrandFreightPrice(prodCostDto.getBrandFreightPrice());
                    offerProdDO.setBrandClearanceFeePrice(prodCostDto.getBrandClearanceFeePrice());
                    offerProdDO.setPackagingFreightPrice(prodCostDto.getPackagingFreightPrice());
                    offerProdDO.setPackagingClearanceFeePrice(prodCostDto.getPackagingClearanceFeePrice());

                    offerProdDO.setDiscountFreightPrice(prodCostDto.getDiscountFreightPrice());
                    offerProdDO.setDiscountFreightTotalPrice(prodCostDto.getDiscountFreightTotalPrice());
                    offerProdDO.setDiscountClearanceFeePrice(prodCostDto.getDiscountClearanceFeePrice());
                    offerProdDO.setDiscountClearanceFeeTotalPrice(prodCostDto.getDiscountClearanceFeeTotalPrice());

                    offerProdDO.setOneSeaFreight(prodCostDto.getOneFreight());
                    offerProdDO.setSeaFreight(prodCostDto.getFreight());
                    offerProdDO.setOriginalSeaFreight(prodCostDto.getOrgFreightPrice());
                    offerProdDO.setSeaFreightVolume(prodCostDto.getFreightVolume());
                    offerProdDO.setSeaFreightCurrency(prodCostDto.getFreightCurrency());

                    offerProdDO.setCharging(prodCostDto.getCharging());
                    offerProdDO.setIsPayAdvance(prodCostDto.getIsPayAdvance());
                }
            }

            if (type != 4) {
                offerProdDO.setOfferId(offer.getOfferId());
                offerProdDO.setStatus(status);
                offerProdMapper.updateById(offerProdDO);
            }
            newProdDOList.add(offerProdDO);
        }
        CalculationProdFeeDto dto = new CalculationProdFeeDto();
        EstCostVO estCostVO = new EstCostVO();
        BeanUtils.copyProperties(resultDto.getCostDto(), estCostVO);
        dto.setEstCostVO(estCostVO);
        dto.setOfferProdDOList(newProdDOList);
        return dto;
    }


    @Override
    @Transactional(rollbackFor = Exception.class)
    public void updateOffer(OfferUpdateReqVO updateReqVO) {
        if (StringUtils.isNotBlank(updateReqVO.getMarks())) {
            // 如果报价单唛头不为空，已校验过格式，需要对长度进行再校验
            if (updateReqVO.getMarks().length() > 20) {
                throw exception(MARKS_LENGTH_MAX, 20);
            }
        }
        if (null == updateReqVO.getStartTime() || null == updateReqVO.getEndTime()) {
            throw exception(OFFER_START_END_TIME_NOT_NULL);
        }
        if (updateReqVO.getRelation() == 1 && (Objects.isNull(updateReqVO.getConsignorId()) || updateReqVO.getConsignorId() == 0)) {
            throw exception(OFFER_ASCRIPTION_CONSIGNOR_NOT_NULL);
        }
        if (updateReqVO.getRelation() == 2 && (Objects.isNull(updateReqVO.getConsigneeId()) || updateReqVO.getConsigneeId() == 0)) {
            throw exception(OFFER_ASCRIPTION_CONSIGNEE_NOT_NULL);
        }
        if (StringUtils.isNotBlank(updateReqVO.getMarks())) {
            if (!StrValidationUtils.isIndexLetterAndLetterDigit(updateReqVO.getMarks()) && updateReqVO.getMarks().length() > 15) {
                throw exception(MARKS_FORMAT_INCORRECT);
            }
        }
        if (Objects.nonNull(updateReqVO.getConsigneeId()) && updateReqVO.getConsigneeId() > 0) {
            if (Objects.isNull(updateReqVO.getControl()) || !updateReqVO.getControl()) {
                // 获取功能开关
                List<DictDataRespDTO> dictList = dictDataApi.getDictDatas("part_function_switch");
                // 智慧预装功能开关
                DictDataRespDTO dictDataRespDTO = dictList.stream().filter(dto -> "create_order_phone_limit".equals(dto.getLabel())).findFirst().orElse(null);
                CustomerContactsDO consigneeContactsDO = customerContactsService.getCustomerContacts(updateReqVO.getConsigneeId());
                if (Objects.nonNull(consigneeContactsDO)) {
                    if (Objects.nonNull(dictDataRespDTO) && StringUtils.equals(dictDataRespDTO.getValue(), "11") && StringUtils.isNotBlank(consigneeContactsDO.getAreaCode()) && StringUtils.equals("86", consigneeContactsDO.getAreaCode())) {
                        throw exception(CONSIGNEE_PHONE_IS_EXTERNAL);
                    }
                }
            }
        }
        String updater = String.valueOf(SecurityFrameworkUtils.getLoginUserId());
        // 校验存在
        OfferDO orgOfferDO = offerMapper.selectById(updateReqVO.getOfferId());
        if (Objects.isNull(orgOfferDO)) {
            throw exception(OFFER_NOT_EXISTS);
        }
        if (orgOfferDO.getStatus() == 3 && updateReqVO.getStatus() == 2) {
            throw exception(OFFER_STATUS_ERROR);
        }
        if (!Objects.equals(orgOfferDO.getStatus(), updateReqVO.getStatus())) {
            updateReqVO.setOldStatus(orgOfferDO.getStatus());
        }
        // 更新
        OfferDO updateObj = OfferConvert.INSTANCE.convert(updateReqVO);
        if (Objects.nonNull(updateReqVO.getEstCostVO())) {
            updateObj.setEstCost(JSONObject.toJSONString(updateReqVO.getEstCostVO()));
        }
        // 查询始发地与目的地信息
        RegionDO departure = regionService.getRegion(updateReqVO.getDepartureId());
        if (Objects.isNull(departure) || (!StrUtil.equals(departure.getType(), "2") && !StrUtil.equals(departure.getType(), "3"))) {
            throw exception(DEPARTURE_NOT_EXISTS);
        }
        RegionDO objective = regionService.getRegion(updateReqVO.getObjectiveId());
        if (Objects.isNull(objective) || (!StrUtil.equals(objective.getType(), "1") && !StrUtil.equals(objective.getType(), "3"))) {
            throw exception(OBJECTIVE_NOT_EXISTS);
        }
        OfferTransportDO offerTransportDO = OfferTransportConvert.INSTANCE.convert(updateReqVO.getTransportVO());
        OfferTransportDO orgOfferTransportDO = offerTransportMapper.selectOne(new LambdaQueryWrapper<OfferTransportDO>().eq(OfferTransportDO::getOfferId, updateObj.getOfferId()).last("limit 1"));

        List<OfferProdDO> offerProdDOList = updateReqVO.getProdUpdateReqVOList().stream().map(OfferProdConvert.INSTANCE::convert).collect(Collectors.toList());

        // 对比商品详情数据源
        List<Long> offerProdIdList = offerProdDOList.stream().filter(tdo -> null != tdo.getOfferProdId() && tdo.getOfferProdId() > 0).map(OfferProdDO::getOfferProdId).collect(Collectors.toList());
        List<Long> oriOfferProdIdList = offerProdMapper.selectIdByOfferId(updateObj.getOfferId());
        List<Long> deleteOfferProdIdList = oriOfferProdIdList.stream().filter(id -> !offerProdIdList.contains(id)).collect(Collectors.toList());
        if (CollectionUtil.isNotEmpty(deleteOfferProdIdList)) {
            offerProdMapper.deleteBatchIds(deleteOfferProdIdList);
        }
        // 报价单关联客户信息保存
        CustomerContactsDO customerContactsDO = customerContactsService.getCustomerContacts(updateObj.getRelation() == 1 ? updateObj.getConsignorId() : updateObj.getConsigneeId());
        if (Objects.isNull(customerContactsDO)) {
            throw exception(CUSTOMER_CONTACTS_NOT_EXISTS);
        }
        updateObj.setRelationId(customerContactsDO.getCustomerId());
        if (Objects.nonNull(customerContactsDO.getCustomerId())) {
            CustomerDO customerDO = customerService.getById(customerContactsDO.getCustomerId());
            if (Objects.nonNull(customerDO) && Objects.nonNull(customerDO.getCustomerService())) {
                updateObj.setFollowUpSalesmanId(String.valueOf(customerDO.getCustomerService()));
                updateObj.setSalesmanId(customerDO.getCustomerService());
                AdminUserRespDTO adminUserRespDTO = adminUserApi.getUser(customerDO.getCustomerService());
                if (Objects.nonNull(adminUserRespDTO)) {
                    updateObj.setDeptId(adminUserRespDTO.getDeptId());
                }
            }
        }
        this.costCalculation(updater, updateObj, offerProdDOList, 2, null);
        offerTransportDO.setOfferTransportId(orgOfferTransportDO.getOfferTransportId());
        offerTransportDO.setOfferId(updateObj.getOfferId());
        offerTransportDO.setTransportId(updateObj.getTransportId());
        offerTransportDO.setLineIds(String.valueOf(updateObj.getLineId()));
        offerTransportDO.setChannelIds(String.valueOf(updateObj.getChannelId()));
        offerTransportMapper.updateById(offerTransportDO);

        this.addOfferLog(updateObj.getOfferId(), updateObj.getNumber(), updateObj.getRelationId(), 2, updater, "修改报价成功");

        //20230302 新需求 报价创建后 就更新线索客户到意向
        Set<Long> idSet = Stream.of(updateObj.getConsigneeId(), updateObj.getConsignorId(), updateObj.getRelationId()).filter(Objects::nonNull).collect(Collectors.toSet());
        for (Long id : idSet) {
            customerService.updateCustomerByCreateOffer(id, new Date());
        }
    }

    @Override
    public void deleteOffer(Long id) {
        // 删除
        offerMapper.deleteById(id);
    }


    @Override
    public OfferDO getOffer(Long id) {
        return offerMapper.selectById(id);
    }

    @Override
    public List<OfferDO> getOfferList(Collection<Long> ids) {
        return offerMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<OfferDO> getOfferPage(OfferPageReqVO pageReqVO) {
        return offerMapper.selectPage(pageReqVO);
    }

    @Override
    public List<OfferDO> getOfferList(OfferExportReqVO exportReqVO) {
        return offerMapper.selectList(exportReqVO);
    }

    @Override
    public OfferRespVO info(Long offerId) {
        OfferDO offerDO = offerMapper.selectById(offerId);
        if (Objects.isNull(offerDO)) {
            throw exception(OFFER_NOT_EXISTS);
        }
        OfferRespVO respVO = OfferConvert.INSTANCE.convert(offerDO);
        EstCostVO estCostVO = JSONObject.parseObject(offerDO.getEstCost(), EstCostVO.class);
        if (Objects.nonNull(estCostVO)) {
            List<FeeDto> feeDtoList = estCostVO.getFeeDtoList();
            if (CollectionUtil.isNotEmpty(feeDtoList)) {
                FeeDto feeDto = feeDtoList.stream().filter(dto -> Objects.equals(FeeTypeEnum.OTHER_FEE.getType(), dto.getFeeType())).findFirst().orElse(null);
                if (Objects.nonNull(feeDto)) {
                    respVO.setOtherFee(feeDto.getAmount());
                    respVO.setOtherFeeCurrencyId(feeDto.getCurrencyId());
                }
            }
        }
        OfferTransportDO offerTransportDO = offerTransportMapper.selectOne(new LambdaQueryWrapper<OfferTransportDO>().eq(OfferTransportDO::getOfferId, offerId).last("limit 1"));
        if (Objects.nonNull(offerTransportDO)) {
            respVO.setTransportVO(OfferTransportConvert.INSTANCE.convert(offerTransportDO));
        }
        List<OfferProdDO> offerProdDOList = offerProdMapper.selectList(new LambdaQueryWrapper<OfferProdDO>().eq(OfferProdDO::getOfferId, offerId).orderByAsc(OfferProdDO::getOfferProdId));
        if (CollectionUtil.isEmpty(offerProdDOList)) {
            throw exception(OFFER_PROD_NOT_NULL);
        }
        respVO.setOfferProdRespVOList(OfferProdConvert.INSTANCE.convertList(offerProdDOList));
        return respVO;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void specialApplyOffer(OfferSpecialApplyVO specialApplyVO) {
        String updater = String.valueOf(SecurityFrameworkUtils.getLoginUserId());
        OfferDO offer = offerMapper.selectById(specialApplyVO.getOfferId());
        Date now = new Date();
        if (Objects.isNull(offer)) {
            throw exception(OFFER_NOT_EXISTS);
        }
        OfferProdDO offerProdDO = offerProdMapper.selectById(specialApplyVO.getOfferProdId());
        if (offerProdDO == null) {
            throw exception(OFFER_PROD_NOT_NULL);
        }
        if (offerProdDO.getStatus() == 1 && specialApplyVO.getApplyStatus() == 0) {
            throw exception(OFFER_PROD_APPROVAL_IN_PROGRESS);
        }

        // 需要查看是否还有其他审批中的商品
        Long count = offerApprovalMapper.selectCount(new LambdaQueryWrapper<OfferApprovalDO>()
                .eq(OfferApprovalDO::getOfferId, offer.getOfferId())
                .eq(OfferApprovalDO::getStatus, 1));
        if (specialApplyVO.getApplyStatus() == 1) {
            if (count > 0) {
                throw exception(OFFER_PROD_SPECIAL_APPLY_NO_MULTIPLE_PROGRESS);
            }
            if (specialApplyVO.getType() == 1 || specialApplyVO.getType() == 2) {
                if (specialApplyVO.getApplyStatus() == 1 || specialApplyVO.getApplyStatus() == 2) {
                    if (Objects.isNull(specialApplyVO.getSeaFreight())) {
                        throw exception(OFFER_SPECIAL_APPLY_SEA_FREIGHT_NOT_NULL);
                    }
                    if (specialApplyVO.getCharging() == 0) {
                        if (Objects.isNull(specialApplyVO.getClearanceFreight())) {
                            throw exception(OFFER_SPECIAL_APPLY_CLEARANCE_FREIGHT_NOT_NULL);
                        }
                    }
                }
            }

            if (specialApplyVO.getType() == 3) {
                if (Objects.isNull(specialApplyVO.getCommissionType())) {
                    throw exception(COMMISSION_TYPE_NOT_NULL);
                }
                // 佣金申请成功 需要重新计算新的运费清关费
                // 需要修改销售单价金额 ，先获取原始不包含佣金的销售单价金额
                specialApplyVO.setOrgCommissionType(offerProdDO.getCommissionType());
                specialApplyVO.setOrgLightCommissionAmount(offerProdDO.getPlainCommission());
                specialApplyVO.setOrgShadeCommissionAmount(offerProdDO.getHiddenCommission());
                BigDecimal saleAmount = offerProdDO.getOneSeaFreight().subtract(offerProdDO.getPlainCommission());
                if (specialApplyVO.getCommissionType() == 0) {
                    specialApplyVO.setLightCommissionAmount(BigDecimal.ZERO);
                    specialApplyVO.setShadeCommissionAmount(BigDecimal.ZERO);
                }
                if (specialApplyVO.getCommissionType() == 1) {
                    specialApplyVO.setShadeCommissionAmount(BigDecimal.ZERO);
                } else if (specialApplyVO.getCommissionType() == 2 || specialApplyVO.getCommissionType() == 3) {
                    BigDecimal costAmount = saleAmount.subtract(specialApplyVO.getShadeCommissionAmount());
                    if (costAmount.compareTo(BigDecimal.ZERO) < 0) {
                        throw exception(FINAL_SALE_FREIGHT_AMOUNT_MUST_GT_ZERO);
                    }
                }
                saleAmount = saleAmount.add(specialApplyVO.getLightCommissionAmount());
                specialApplyVO.setSeaFreight(saleAmount);
            }
            offer.setOldStatus(offer.getStatus());
            offer.setStatus(1); // 特价申请中
            offer.setUpdater(updater);
            offer.setUpdateTime(now);
            offerMapper.updateById(offer);
            OfferApprovalDO offerApprovalDO = new OfferApprovalDO();
            offerApprovalDO.setOfferId(offer.getOfferId());
            offerApprovalDO.setOfferProdId(specialApplyVO.getOfferProdId());
            offerApprovalDO.setFollowUpSalesmanId(updater);
            offerApprovalDO.setDetails(JSONObject.toJSONString(specialApplyVO));
            offerApprovalDO.setType(Objects.isNull(specialApplyVO.getType()) ? 1 : specialApplyVO.getType());
            offerApprovalDO.setStatus(1);
            offerApprovalDO.setCreateTime(new Date());
            offerApprovalDO.setCreator(updater);
            offerApprovalMapper.insert(offerApprovalDO);
            String formId = bpmCreateServiceFactory.createBmp(Long.valueOf(updater), offerApprovalDO.getOfferApprovalId(),
                    specialApplyVO.getType() == 1 ? WorkFlowEmus.QUOTATION_SHEET_SALE.getKey() : WorkFlowEmus.QUOTATION_COMMISSION_CONFIG.getKey(), offer.getNumber(),
                    StringUtils.isNotBlank(specialApplyVO.getCcIds()) ? specialApplyVO.getCcIds().split(StrUtil.COMMA) : null);
            offerApprovalDO.setFormId(formId);
            offerApprovalMapper.updateById(offerApprovalDO);
            offerProdDO.setStatus(1);
            offerProdDO.setUpdater(updater);
            offerProdDO.setUpdateTime(now);
            offerProdMapper.updateById(offerProdDO);
            this.addOfferLog(offer.getOfferId(), offer.getNumber(), offer.getRelationId(), 3, updater,
                    String.format(offerApprovalDO.getType() == 1 ? "商品ID【%s】名称【%s】特价优惠审批申请" : "商品ID【%s】名称【%s】佣金设置审批申请", offerProdDO.getProdId(), I18nMessage.getLang() == 0 ? offerProdDO.getProdTitleZh() : offerProdDO.getProdTitleEn()));
        } else if (specialApplyVO.getApplyStatus() == 2) {
            // 审批通过
            offerProdDO.setStatus(2);
            offerProdDO.setCharging(specialApplyVO.getCharging());
            offerProdDO.setIsPayAdvance(specialApplyVO.getIsPayAdvance());
            if (specialApplyVO.getType() == 1 || specialApplyVO.getType() == 2) {
                offerProdDO.setSpecialPriceType(Boolean.TRUE);
                offerProdDO.setOneSeaFreight(specialApplyVO.getSeaFreight());
                offerProdDO.setOneClearanceFreight(specialApplyVO.getClearanceFreight());
            }
            if (specialApplyVO.getType() == 3) {
                // 计算新的销售价
                BigDecimal saleAmount = offerProdDO.getOneSeaFreight().subtract(offerProdDO.getPlainCommission()).add(specialApplyVO.getLightCommissionAmount());
                offerProdDO.setCommissionType(specialApplyVO.getCommissionType());
                offerProdDO.setSpecialCommission(Boolean.TRUE);
                offerProdDO.setPlainCommission(specialApplyVO.getLightCommissionAmount());
                offerProdDO.setHiddenCommission(specialApplyVO.getShadeCommissionAmount());
                offerProdDO.setOneSeaFreight(saleAmount);// 佣金变动 成交单价也变动
            }
            offerProdDO.setUpdater(updater);
            offerProdDO.setUpdateTime(now);
            offerProdMapper.updateById(offerProdDO);
            if (count == 0) {
                offer.setOldStatus(offer.getStatus());
                offer.setStatus(3);
                offer.setUpdater(updater);
                offer.setUpdateTime(now);
                offerMapper.updateById(offer);
            }
            List<OfferProdDO> offerProdDOList = offerProdMapper.selectList(new LambdaQueryWrapper<OfferProdDO>()
                    .eq(OfferProdDO::getOfferId, offer.getOfferId()).eq(OfferProdDO::getDeleted, 0));
            this.costCalculation(updater, offer, offerProdDOList, 3, specialApplyVO);

            this.addOfferLog(offer.getOfferId(), offer.getNumber(), offer.getRelationId(), 3, updater,
                    String.format(specialApplyVO.getType() == 1 ? "商品ID【%s】名称【%s】特价优惠审批通过" : "商品ID【%s】名称【%s】佣金设置审批通过", offerProdDO.getProdId(), I18nMessage.getLang() == 0 ? offerProdDO.getProdTitleZh() : offerProdDO.getProdTitleEn()));
        } else {
            // 审批未通过
            offerProdDO.setStatus(0);
            offerProdDO.setUpdater(updater);
            offerProdDO.setUpdateTime(now);
            offerProdMapper.updateById(offerProdDO);
            // 需要查看是否还有其他审批中的商品
            if (count == 0) {
                offer.setOldStatus(offer.getStatus());
                offer.setStatus(3);
                offer.setUpdater(updater);
                offer.setUpdateTime(now);
                offerMapper.updateById(offer);
            }
            this.addOfferLog(offer.getOfferId(), offer.getNumber(), offer.getRelationId(), 3, updater,
                    String.format(specialApplyVO.getType() == 1 ? "商品ID【%s】名称【%s】特价优惠审批未通过" : "商品ID【%s】名称【%s】佣金设置审批未通过", offerProdDO.getProdId(), I18nMessage.getLang() == 0 ? offerProdDO.getProdTitleZh() : offerProdDO.getProdTitleEn()));
        }

    }


    /**
     * @param userId          操作用户ID
     * @param offerDO         报价单主体
     * @param offerProdDOList 报价单商品列表
     * @param type            类型 ： 1 新增 2 修改 3 特价申请
     * @param specialApplyVO  特价申请的商品新基础运费信息
     */
    private void costCalculation(String userId, OfferDO offerDO, List<OfferProdDO> offerProdDOList,
                                 Integer type, OfferSpecialApplyVO specialApplyVO) {
        LogisticsInfoDto logisticsInfoDto = warehouseLineMapper.getStartInfoAndDestInfoByLineId(offerDO.getLineId());

        if (Objects.isNull(logisticsInfoDto)) {
            throw exception(TRANSPORT_LINE_NOT_EXISTS);
        }
        CustomerZhongPaoQueryVO customerZhongPaoQueryVO = new CustomerZhongPaoQueryVO();
        customerZhongPaoQueryVO.setConsignorId(offerDO.getConsignorId());
        customerZhongPaoQueryVO.setConsigneeId(offerDO.getConsigneeId());
        customerZhongPaoQueryVO.setDepartureId(logisticsInfoDto.getStartCityId());
        customerZhongPaoQueryVO.setObjectiveId(logisticsInfoDto.getDestCityId());
        customerZhongPaoQueryVO.setStartWarehouseId(logisticsInfoDto.getStartWarehouseId());
        customerZhongPaoQueryVO.setDestWarehouseId(logisticsInfoDto.getDestWarehouseId());
        ZhongPaoBestVO zhongPaoBestVO = zhongPaoService.getCustomerBestZhongPao(customerZhongPaoQueryVO);
        // 批量转换报价单商品
        CalculationProdFeeDto dto = this.insertOfferProdDOList(offerProdDOList, offerDO, zhongPaoBestVO, type, specialApplyVO);
        EstCostVO newEstCostVO = dto.getEstCostVO();
        List<FeeDto> newFeeDtoList = newEstCostVO.getFeeDtoList();
        if (Objects.nonNull(offerDO.getOtherFee()) && offerDO.getOtherFee().compareTo(BigDecimal.ZERO) > 0 &&
                Objects.nonNull(offerDO.getOtherFeeCurrencyId()) && offerDO.getOtherFeeCurrencyId() > 0) {
            FeeDto feeDto = new FeeDto();
            feeDto.setFeeType(FeeTypeEnum.OTHER_FEE.getType());
            feeDto.setAmount(offerDO.getOtherFee());
            feeDto.setCurrencyId(offerDO.getOtherFeeCurrencyId());
            newFeeDtoList.add(feeDto);
        }
        if (StringUtils.isNotBlank(offerDO.getEstCost())) {
            EstCostVO orgEstCostVO = JSONObject.parseObject(offerDO.getEstCost(), EstCostVO.class);
            if (CollectionUtil.isNotEmpty(orgEstCostVO.getFeeDtoList())) {
                for (FeeDto feeDto : orgEstCostVO.getFeeDtoList()) {
                    if (!Objects.equals(feeDto.getFeeType(), FeeTypeEnum.FREIGHT.getType())
                            && !Objects.equals(feeDto.getFeeType(), FeeTypeEnum.CLEARANCE_FEE.getType())
                            && !Objects.equals(feeDto.getFeeType(), FeeTypeEnum.INSURANCE_FEE.getType())
                            && !Objects.equals(feeDto.getFeeType(), FeeTypeEnum.WORTH.getType())
                            && !Objects.equals(feeDto.getFeeType(), FeeTypeEnum.OTHER_FEE.getType())) {
                        newFeeDtoList.add(feeDto);
                    }
                }
            }
        }
        newEstCostVO.setFeeDtoList(newFeeDtoList);
        offerDO.setEstCost(JSONObject.toJSONString(newEstCostVO));
        offerDO.setUpdater(userId);
        if (type == 3) {
            // 需要查看是否还有其他审批中的商品
            Long count = offerApprovalMapper.selectCount(new LambdaQueryWrapper<OfferApprovalDO>().eq(OfferApprovalDO::getOfferId, offerDO.getOfferId()).eq(OfferApprovalDO::getStatus, 1));
            if (count == 0) {
                offerDO.setOldStatus(offerDO.getStatus());
                offerDO.setStatus(3);
            }
        }
        offerMapper.updateById(offerDO);
    }


    @Override
    @Transactional(rollbackFor = Exception.class)
    public Long updateOfferResult(OfferResultVO offerResultVO) {
        String results;
        String updater = String.valueOf(SecurityFrameworkUtils.getLoginUserId());
        OfferDO offerDO = offerMapper.selectById(offerResultVO.getOfferId());
        if (Objects.isNull(offerDO)) {
            throw exception(OFFER_NOT_EXISTS);
        }
        if (offerDO.getStatus() == 5 || offerDO.getStatus() == 4) {
            throw exception(OFFER_IS_END, offerDO.getNumber());
        }
        if (offerResultVO.getResult() == 0) {
            // 输单
            offerDO.setReason(offerResultVO.getReason());
            offerDO.setOldStatus(offerDO.getStatus());
            offerDO.setStatus(5);
            offerDO.setOrderId(-1L);
            results = "报价单输单";
        } else {
            // 赢单
            if (null == offerResultVO.getWarehousingType()) {
                throw exception(WAREHOUSING_TYPE_NOT_NULL);
            }
            offerDO.setWarehousingType(offerResultVO.getWarehousingType());
            if (Objects.isNull(offerDO.getOrderId()) || offerDO.getOrderId() == 0L) {

                // TODO 注意校验关联订单
                OrderDO orderDO;
                if (StringUtils.isNotBlank(offerResultVO.getOrderNo())) {
                    orderDO = orderService.getOne(new LambdaQueryWrapper<OrderDO>().eq(OrderDO::getOrderNo, offerResultVO.getOrderNo()).last("limit 1"));
                    if (Objects.isNull(orderDO)) {
                        throw exception(ORDER_NOT_FIND);
                    }
                    // 查询该订单是否有绑定报价单
                    OfferDO offer = offerMapper.selectOne(new LambdaQueryWrapper<OfferDO>().eq(OfferDO::getOfferId, orderDO.getOrderId()).last("limit 1"));
                    if (Objects.nonNull(offer)){
                        throw exception(ORDER_BOUND_OFFER);
                    }
                    //如果订单关联上报价单
                    if(orderDO!=null && offerDO.getOfferId()!=null){
                        this.checkOrderSalesman(orderDO,offerDO.getOfferId()) ;
                    }

                } else {
                    orderDO = this.generateOrder(offerDO, offerResultVO);
                    if (Objects.isNull(orderDO)) {
                        throw exception(ORDER_CREATE_FAIL);
                    }
                }
                if (StringUtils.isNotBlank(orderDO.getOrderNo()) && !orderDO.getOrderNo().contains("DRAFT")) {
                    offerDO.setOrderNo(orderDO.getOrderNo());
                }
                offerDO.setOrderId(orderDO.getOrderId());
                offerDO.setOldStatus(offerDO.getStatus());
            }
            offerDO.setStatus(4);
            results = "报价单赢单";
        }
        offerDO.setUpdater(updater);
        offerDO.setUpdateTime(new Date());
        offerMapper.updateById(offerDO);

        this.addOfferLog(offerDO.getOfferId(), offerDO.getNumber(), offerDO.getRelationId(), 6, updater, results);
        return offerDO.getOrderId();
    }

    /**
     * 赢单处理报价单时，再次判断业绩归属
     * @param orderDO
     * @param offerId
     */
    private void checkOrderSalesman(OrderDO orderDO, Long offerId) {
      orderService.checkOrderSalesman(orderDO,offerId,null,null,null,null);
      orderService.updateOrderCustomerAndSalesmanId(orderDO.getCustomerId()!=null?orderDO.getCustomerId():0,orderDO.getSalesmanId()!=null?orderDO.getSalesmanId():0,orderDO.getOrderId()) ;
    }

    private OrderDO generateOrder(OfferDO offerDO, OfferResultVO offerResultVO) {
        OfferTransportDO offerTransportDO = offerTransportMapper.selectOne(new LambdaQueryWrapper<OfferTransportDO>().eq(OfferTransportDO::getOfferId, offerDO.getOfferId()).last("limit 1"));
        List<OfferProdDO> prodDOList = offerProdMapper.selectList(new LambdaQueryWrapper<OfferProdDO>().eq(OfferProdDO::getOfferId, offerDO.getOfferId()));
        Long lineId = offerDO.getLineId();

        Long channelId = offerDO.getChannelId();

        OrderCreateReqVO createReqVO = new OrderCreateReqVO();
        createReqVO.setCustomerId(offerDO.getRelationId());
        createReqVO.setStatus(OrderStatusEnum.DRAFT.getValue());
        createReqVO.setDepartureId(offerDO.getDepartureId());
        createReqVO.setObjectiveId(offerDO.getObjectiveId());
        createReqVO.setMarks(offerDO.getMarks());
        createReqVO.setType(offerDO.getServiceType());
        createReqVO.setChannelId(channelId);
        createReqVO.setLineId(lineId);
        createReqVO.setTransportId(offerDO.getTransportId());
        createReqVO.setShippingCompany(offerTransportDO.getShippingCompany());
        createReqVO.setAirlineCompany(offerTransportDO.getAirlineCompany());
        createReqVO.setIsSingleTicketTransport(offerTransportDO.getIsSingleTicketTransport());
        createReqVO.setIssuingMethod(offerTransportDO.getIssuingMethod());
        createReqVO.setIsUnpack(offerTransportDO.getIsUnpack());
        createReqVO.setCustomsClearCert(offerTransportDO.getCustomsClearCert());
        createReqVO.setIsSingleTicketTransport(offerTransportDO.getIsSingleTicketTransport());
        createReqVO.setWarehouseType(offerResultVO.getWarehousingType());
        createReqVO.setPackageType(offerTransportDO.getPackageType());
        createReqVO.setPackageRemarks(offerTransportDO.getPackageRemarks());
        createReqVO.setDrawee(2);
        createReqVO.setIsCargoControl(offerDO.getControl());

        CustomerContactsDO consignorContactsDO = customerContactsService.getCustomerContacts(offerDO.getConsignorId());
        if (Objects.nonNull(consignorContactsDO)) {
            createReqVO.setConsignorId(consignorContactsDO.getCustomerId());
            createReqVO.setConsignorContactsId(consignorContactsDO.getId());
        }
        CustomerContactsDO consigneeContactsDO = customerContactsService.getCustomerContacts(offerDO.getConsigneeId());
        if (Objects.nonNull(consigneeContactsDO)) {
            createReqVO.setConsigneeId(consigneeContactsDO.getCustomerId());
            CustomerDO consigneeDO = customerService.getCustomer(consigneeContactsDO.getCustomerId());
            if (Objects.nonNull(consigneeDO)) {
                createReqVO.setConsigneeAddress(consigneeDO.getAddress());
            }
            createReqVO.setConsigneeContactsId(consigneeContactsDO.getId());
        }

        List<OrderItemCreateReqVO> orderItemVOList = new ArrayList<>();
        for (OfferProdDO prod : prodDOList) {
            if (Objects.equals(prod.getTransportId(), offerDO.getTransportId())
                    && Objects.equals(prod.getLineId(), lineId)
                    && (channelId == null || (Objects.equals(prod.getChannelId(), channelId)))) {
                OrderItemCreateReqVO itemCreateReqVO = new OrderItemCreateReqVO();
                itemCreateReqVO.setChannelId(channelId);
                itemCreateReqVO.setLineId(lineId);
                itemCreateReqVO.setTransportId(offerDO.getTransportId());
                itemCreateReqVO.setNum(prod.getNum());
                itemCreateReqVO.setQuantity(prod.getQuantity());
                itemCreateReqVO.setBoxGauge(prod.getBoxGauge());
                itemCreateReqVO.setBrandType(prod.getBrand());
                itemCreateReqVO.setCharging(prod.getCharging());


                itemCreateReqVO.setCharging(prod.getCharging());
                // 是否特价
                itemCreateReqVO.setSpecialPriceType(prod.getSpecialPriceType());
                itemCreateReqVO.setIsPriced(prod.getSpecialPriceType());
                itemCreateReqVO.setOriginalClearanceFreight(prod.getOriginalClearanceFreight());
                itemCreateReqVO.setClearanceFreight(prod.getClearanceFreight());
                itemCreateReqVO.setOneClearanceFreight(prod.getOneClearanceFreight());
                itemCreateReqVO.setClearanceFreightCurrency(prod.getClearanceFreightCurrency());
                itemCreateReqVO.setClearanceFreightVolume(prod.getClearanceFreightVolume());

                itemCreateReqVO.setOriginalSeaFreight(prod.getOriginalSeaFreight());
                itemCreateReqVO.setSeaFreight(prod.getSeaFreight());
                itemCreateReqVO.setOneSeaFreight(prod.getOneSeaFreight());
                itemCreateReqVO.setSeaFreightCurrency(prod.getSeaFreightCurrency());
                itemCreateReqVO.setSeaFreightVolume(prod.getSeaFreightVolume());

                itemCreateReqVO.setSpecialCommission(prod.getSpecialCommission());
                itemCreateReqVO.setCommissionType(prod.getCommissionType());
                itemCreateReqVO.setPlainCommission(prod.getPlainCommission());
                itemCreateReqVO.setHiddenCommission(prod.getHiddenCommission());

                itemCreateReqVO.setDiscountClearanceFeePrice(prod.getDiscountClearanceFeePrice());
                itemCreateReqVO.setDiscountClearanceFeeTotalPrice(prod.getDiscountClearanceFeeTotalPrice());
                itemCreateReqVO.setDiscountFreightPrice(prod.getDiscountFreightPrice());
                itemCreateReqVO.setDiscountFreightTotalPrice(prod.getDiscountFreightTotalPrice());

                itemCreateReqVO.setLiquidFreightPrice(prod.getLiquidFreightPrice());
                itemCreateReqVO.setLiquidClearanceFeePrice(prod.getLiquidClearanceFeePrice());

                itemCreateReqVO.setElectrifiedFreightPrice(prod.getElectrifiedFreightPrice());
                itemCreateReqVO.setElectrifiedClearanceFeePrice(prod.getElectrifiedClearanceFeePrice());

                itemCreateReqVO.setBrandFreightPrice(prod.getBrandFreightPrice());
                itemCreateReqVO.setBrandClearanceFeePrice(prod.getBrandClearanceFeePrice());

                itemCreateReqVO.setPackagingFreightPrice(prod.getPackagingFreightPrice());
                itemCreateReqVO.setPackagingClearanceFeePrice(prod.getPackagingClearanceFeePrice());

                itemCreateReqVO.setIsPayAdvance(prod.getIsPayAdvance());
                itemCreateReqVO.setProdId(prod.getProdId());
                itemCreateReqVO.setProdTitleEn(prod.getProdTitleEn());
                itemCreateReqVO.setProdTitleZh(prod.getProdTitleZh());
                itemCreateReqVO.setProdAttrIds(prod.getProdAttrIds());
                itemCreateReqVO.setLink(prod.getLink());

                itemCreateReqVO.setExpressNo(prod.getExpressNo());
                itemCreateReqVO.setUnit(prod.getUnit());
                itemCreateReqVO.setVolume(prod.getVolume());
                itemCreateReqVO.setWeight(prod.getWeight());
                itemCreateReqVO.setWorth(prod.getWorth());
                itemCreateReqVO.setWorthCurrency(prod.getWorthCurrency());
                itemCreateReqVO.setProdType(prod.getProductType());
                orderItemVOList.add(itemCreateReqVO);
            }
        }
        createReqVO.setOrderItemVOList(orderItemVOList);
        return orderService.createOrder(createReqVO, null);
    }


    @Override
    public PageResult<OfferRespVO> offerPage(OfferPageReqVO pageReqVO) {
        IPage<OfferRespVO> mpPage = MyBatisUtils.buildPage(pageReqVO);
        pageReqVO.setPageNo((int) ((mpPage.getCurrent() - 1) * mpPage.getSize()));
        pageReqVO.setPageSize((int) ((mpPage.getSize())));
        Long total = offerMapper.countOfferList(pageReqVO);
        log.warn(I18nMessage.getLang().toString());
        List<OfferRespVO> list = offerMapper.offerPage(pageReqVO, I18nMessage.getLang());
        return new PageResult<>(list, total, mpPage.getSize(), mpPage.getCurrent(), (total + mpPage.getSize() - 1) / mpPage.getSize());

    }

//    @Override
//    public PageResult<OfferRespVO> deptOfferPage(OfferPageReqVO pageReqVO) {
//        IPage<OfferRespVO> mpPage = MyBatisUtils.buildPage(pageReqVO);
//        pageReqVO.setPageNo((int) ((mpPage.getCurrent() - 1) * mpPage.getSize()));
//        pageReqVO.setPageSize((int) (mpPage.getSize()));
//        Long total = offerMapper.countOfferList(pageReqVO);
//        log.warn(I18nMessage.getLang().toString());
//        List<OfferRespVO> list = offerMapper.offerPage(pageReqVO, I18nMessage.getLang());
//        return new PageResult<>(list, total, mpPage.getSize(), mpPage.getCurrent(), (total + mpPage.getSize() - 1) / mpPage.getSize());
//
//    }


    @Override
    public OfferApprovalBackInfoVO approvalOfferInfo(Long approveId) {
        OfferApprovalDO approvalDO = offerApprovalMapper.selectById(approveId);
        if (approvalDO == null) {
            throw exception(OFFER_SPECIAL_APPLY_FORM_DETAILS_NOT_EXISTS);
        }
        OfferApprovalBackInfoVO infoVO = offerProdMapper.getOfferProdApprovalInfo(approvalDO.getOfferProdId(), I18nMessage.getLang());
        if (Objects.isNull(infoVO)) {
            throw exception(OFFER_PROD_NOT_NULL);
        }
        OfferApprovalBackVO backVO = OfferApprovalConvert.INSTANCE.convert(approvalDO);
        infoVO.setOfferApprovalId(backVO.getOfferApprovalId());
        infoVO.setFormId(backVO.getFormId());
        infoVO.setFollowUpSalesmanId(backVO.getFollowUpSalesmanId());
        infoVO.setType(backVO.getType());
        infoVO.setProcessingResults(backVO.getProcessingResults());
        infoVO.setStatus(backVO.getStatus());
        infoVO.setType(backVO.getType());
        if (StringUtils.isNotBlank(approvalDO.getDetails())) {
            OfferSpecialApplyVO applyVO = JSONObject.parseObject(approvalDO.getDetails(), OfferSpecialApplyVO.class);
            infoVO.setApplyStatus(applyVO.getApplyStatus());
            infoVO.setApplyResult(applyVO.getApplyResult());
            infoVO.setClearanceFreight(applyVO.getClearanceFreight());
            infoVO.setClearanceFreight(applyVO.getClearanceFreight());
            infoVO.setClearanceFreightCurrency(applyVO.getClearanceFreightCurrency());
            infoVO.setClearanceFreightVolume(applyVO.getClearanceFreightVolume());
            infoVO.setOrgClearanceFreight(applyVO.getOrgClearanceFreight());
            if (backVO.getType() == 3) {
                infoVO.setOrgSeaFreight(applyVO.getOrgSeaFreight());
                infoVO.setSeaFreight(applyVO.getOrgSeaFreight().subtract(applyVO.getOrgLightCommissionAmount().add(applyVO.getLightCommissionAmount())));
                // 成本价格 = 销售价 - 明佣 - 暗佣
                infoVO.setCostSeaFreight(infoVO.getSeaFreight().subtract(applyVO.getLightCommissionAmount()).subtract(applyVO.getShadeCommissionAmount()));
            } else {
                infoVO.setOrgSeaFreight(applyVO.getOrgSeaFreight());
                infoVO.setSeaFreight(applyVO.getSeaFreight());
            }
            infoVO.setSeaFreightCurrency(applyVO.getSeaFreightCurrency());
            infoVO.setSeaFreightVolume(applyVO.getSeaFreightVolume());

            infoVO.setCommissionType(applyVO.getCommissionType());
            infoVO.setLightCommissionAmount(applyVO.getLightCommissionAmount());
            infoVO.setShadeCommissionAmount(applyVO.getShadeCommissionAmount());
        }
        return infoVO;
    }


    @Override
    public OfferApprovalBackInfoVO approvalOfferSpecialByOfferProdId(Integer type, Long offerProdId, boolean isResubmit) {
        OfferApprovalBackInfoVO infoVO = offerProdMapper.getOfferProdApprovalInfo(offerProdId, I18nMessage.getLang());
        if (Objects.isNull(infoVO)) {
            throw exception(OFFER_PROD_NOT_NULL);
        }
        OfferApprovalDO approvalDO = offerApprovalMapper.selectOne(new LambdaQueryWrapper<OfferApprovalDO>()
                .eq(OfferApprovalDO::getOfferProdId, offerProdId)
                .eq(OfferApprovalDO::getType, type)
                .orderByDesc(OfferApprovalDO::getOfferApprovalId)
                .last("limit 1"));
        isResubmit = Objects.isNull(approvalDO) || 1 != approvalDO.getStatus();
        if (Objects.nonNull(approvalDO) && !isResubmit) {
            OfferApprovalBackVO backVO = OfferApprovalConvert.INSTANCE.convert(approvalDO);
            infoVO.setOfferApprovalId(backVO.getOfferApprovalId());
            infoVO.setFormId(backVO.getFormId());
            infoVO.setFollowUpSalesmanId(backVO.getFollowUpSalesmanId());
            infoVO.setType(backVO.getType());
            infoVO.setProcessingResults(backVO.getProcessingResults());
            infoVO.setStatus(backVO.getStatus());
            infoVO.setType(backVO.getType());
            if (StringUtils.isNotBlank(approvalDO.getDetails())) {
                OfferSpecialApplyVO applyVO = JSONObject.parseObject(approvalDO.getDetails(), OfferSpecialApplyVO.class);
                infoVO.setApplyStatus(applyVO.getApplyStatus());
                infoVO.setApplyResult(applyVO.getApplyResult());
                infoVO.setClearanceFreight(applyVO.getClearanceFreight());
                infoVO.setCostClearanceFreight(applyVO.getClearanceFreight());
                infoVO.setClearanceFreightCurrency(applyVO.getClearanceFreightCurrency());
                infoVO.setClearanceFreightVolume(applyVO.getClearanceFreightVolume());
                infoVO.setOrgClearanceFreight(applyVO.getOrgClearanceFreight());
                if (backVO.getType() == 3) {
                    infoVO.setOrgSeaFreight(applyVO.getOrgSeaFreight());
                    infoVO.setSeaFreight(applyVO.getOrgSeaFreight().subtract(applyVO.getOrgLightCommissionAmount().add(applyVO.getLightCommissionAmount())));
                    // 成本价格 = 销售价 - 明佣 - 暗佣
                    infoVO.setCostSeaFreight(infoVO.getSeaFreight().subtract(applyVO.getLightCommissionAmount()).subtract(applyVO.getShadeCommissionAmount()));
                } else {
                    infoVO.setOrgSeaFreight(applyVO.getOrgSeaFreight());
                    infoVO.setSeaFreight(applyVO.getSeaFreight());
                }
                infoVO.setSeaFreightCurrency(applyVO.getSeaFreightCurrency());
                infoVO.setSeaFreightVolume(applyVO.getSeaFreightVolume());
                infoVO.setCommissionType(applyVO.getCommissionType());
                infoVO.setLightCommissionAmount(applyVO.getLightCommissionAmount());
                infoVO.setShadeCommissionAmount(applyVO.getShadeCommissionAmount());
                infoVO.setSubtotalFreight(applyVO.getSubtotalFreight());
                infoVO.setSubtotalClearanceFreight(applyVO.getSubtotalClearanceFreight());
            }
        } else {
            if (type == 3) {
                infoVO.setOrgSeaFreight(infoVO.getSeaFreight());
                infoVO.setOrgClearanceFreight(infoVO.getClearanceFreight());
                infoVO.setCostSeaFreight(infoVO.getOrgSeaFreight().subtract(infoVO.getOrgLightCommissionAmount()).subtract(infoVO.getOrgShadeCommissionAmount()));
                infoVO.setCostClearanceFreight(infoVO.getOrgClearanceFreight());
            } else {
                infoVO.setOrgSeaFreight(infoVO.getSeaFreight());
                infoVO.setSeaFreight(null);
                infoVO.setOrgClearanceFreight(infoVO.getClearanceFreight());
                infoVO.setClearanceFreight(null);
            }
        }
        return infoVO;
    }


    /**
     * @param approveId 表单业务ID
     * @param result    1 处理中  2 通过 3 不通过 4 已取消
     */
    @Override
    public void approvalOffer(String approveId, Integer result) {

        if (result == 1) {
            return;
        }
        Long userId = SecurityFrameworkUtils.getLoginUserId();
        OfferApprovalDO approvalDO = offerApprovalMapper.selectById(approveId);
        if (approvalDO == null) {
            throw exception(OFFER_SPECIAL_APPLY_FORM_DETAILS_NOT_EXISTS);
        }
        if (approvalDO.getStatus() != 1) {
            throw exception(OFFER_SPECIAL_APPLY_FORM_APPROVAL_FINISH);
        }
        approvalDO.setStatus(result);
        approvalDO.setFinishBy(String.valueOf(userId));
        approvalDO.setFinishTime(new Date());

        // 结束审批，则向报价单主体提交结果
//        if (approvalDO.getType() == 1) {
        // 特价申请
        OfferSpecialApplyVO offerSpecialApplyVO = new OfferSpecialApplyVO();
        if (StringUtils.isNotBlank(approvalDO.getDetails())) {
            offerSpecialApplyVO = JSONObject.parseObject(approvalDO.getDetails(), OfferSpecialApplyVO.class);
        }
        if (null == offerSpecialApplyVO.getOfferId()) {
            offerSpecialApplyVO.setOfferId(approvalDO.getOfferId());
            offerSpecialApplyVO.setOfferProdId(approvalDO.getOfferProdId());
        }
        offerSpecialApplyVO.setApplyStatus(result);
        offerSpecialApplyVO.setApplyResult(result == 2 ? "通过" : (result == 3 ? "不通过" : "已取消"));
        approvalDO.setDetails(JSONObject.toJSONString(offerSpecialApplyVO));
        offerApprovalMapper.updateById(approvalDO);
        this.specialApplyOffer(offerSpecialApplyVO);

//        }

    }

    @Override
    public void cancelOfferSpecialApproval(Long offerApprovalId, String reason) {
        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        Long userId = loginUser != null ? loginUser.getId() : null;

        OfferApprovalDO approvalDO = offerApprovalMapper.selectById(offerApprovalId);
        if (Objects.isNull(approvalDO)) {
            throw exception(OFFER_APPROVAL_NOT_EXISTS);
        }
        if (approvalDO.getDeleted() || (approvalDO.getType() != 1 && approvalDO.getType() != 2
                && approvalDO.getStatus() != 1)) {
            throw exception(OFFER_APPROVAL_STATUS_NOT_CORRECT);
        }
        if (Objects.isNull(approvalDO.getFormId())) {
            throw exception(OFFER_APPROVAL_FORM_ID_NOT_EXISTS);
        }
        bpmCreateServiceFactory.cancelBmpById(userId, approvalDO.getFormId(), reason);
    }

    @Override
    public void cancelOffer(Long id) {
        OfferDO offerDO = offerMapper.selectById(id);
        offerDO.setOldStatus(offerDO.getStatus());
        offerDO.setStatus(0);
        offerMapper.updateById(offerDO);
    }

    @Override
    public void recoveryOffer(Long id) {
        OfferDO offerDO = offerMapper.selectById(id);
        if (offerDO.getStatus() != 0) {
            throw exception(RECOVERY_CANCEL_OFFER_STATUS_ERROR);
        }
        if (offerDO.getEndTime().compareTo(new Date()) < 0) {
            throw exception(RECOVERY_CANCEL_OFFER_TIME_EXPIRE);
        }
        offerDO.setStatus(offerDO.getOldStatus());
        offerDO.setOldStatus(0);
        offerMapper.updateById(offerDO);
    }


    @Override
    public void exportOfferExcel(HttpServletResponse response, OfferPageReqVO pageReqVO) throws IOException {
        // 获取所有货币
        List<CurrencyDO> currencyDOList = currencyService.list();
        if (CollectionUtil.isEmpty(currencyDOList)) {
            throw exception(NOT_FIND_CURRENCY);
        }
        Map<Integer, CurrencyDO> currencyDOMap = currencyDOList.stream()
                .collect(Collectors.toMap(CurrencyDO::getId, Function.identity(), (key1, key2) -> key2));
        // 获取清单费用类型
        List<DictDataRespDTO> dictDataRespDTOList = dictDataApi.getDictDatas("cost_fee_type");
        Map<String, DictDataRespDTO> dictDataRespDTOMap = dictDataRespDTOList.stream()
                .collect(Collectors.toMap(DictDataRespDTO::getValue, Function.identity(), (key1, key2) -> key2));

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern(DATA_FORMAT);
        String nowTime = formatter.format(LocalDateTime.now());

        response.setContentType(CONTENT_TYPE);
        //设置字符集为utf-8
        response.setCharacterEncoding(CHARACTER_UTF_8);
        String sheetName = I18nMessage.getLang() == 0 ? "报价单管理" : "Offer Management";
        String fileName = sheetName.concat("_").concat(nowTime).concat(".xlsx");

        //文件名乱码解决：用postman测正常，浏览器多了filename_=utf-8等字样
        response.setHeader(CONTENT_DISPOSITION,
                "attachment;filename=" + URLEncoder.encode(fileName, CHARACTER_UTF_8)
                        + ";filename*=utf-8''" + URLEncoder.encode(fileName, CHARACTER_UTF_8));

        //发送一个报头，告诉浏览器当前页面不进行缓存，每次访问的时间必须从服务器上读取最新的数据
        response.setHeader(CACHE_CONTROL, NO_STORE);
        response.addHeader(CACHE_CONTROL, MAX_AGE);

        ServletOutputStream out = response.getOutputStream();
        ExcelWriter excelWriter = EasyExcel.write(out, OfferExcelVO.class).build();
        WriteSheet writeSheet = EasyExcel.writerSheet(sheetName).build();
        Long total = offerMapper.countOfferList(pageReqVO);
        int pageNumber = (int) Math.ceil((double) total / (double) PAGE_SIZE);    //分页条数看情况
        // 去调用写入,根据数据库分页的总的页数来
        for (int i = 1; i <= pageNumber; i++) {
            //先定义一个空集合每次循环使他变成null减少内存的占用
            pageReqVO.setPageNo((i - 1) * PAGE_SIZE);
            pageReqVO.setPageSize(PAGE_SIZE);
            List<OfferRespVO> list = offerMapper.offerPage(pageReqVO, I18nMessage.getLang());
            List<OfferExcelVO> pageList = OfferConvert.INSTANCE.convertList03(list);
            pageList = pageList.stream().peek(excData -> {
                if (StringUtils.isNotBlank(excData.getEstCost())) {
                    StringBuilder sb = new StringBuilder();
                    EstCostVO estCostVO = JSONObject.parseObject(excData.getEstCost(), EstCostVO.class);
                    for (FeeDto feeDto : estCostVO.getFeeDtoList()) {
                        if (Arrays.asList(1, 2, 3, 5, 8).contains(feeDto.getFeeType())) {
                            CurrencyDO currencyDO = currencyDOMap.get(feeDto.getCurrencyId());
                            if (Objects.isNull(currencyDO)) {
                                continue;
                            }
                            if (StringUtils.isNotBlank(sb)) {
                                sb.append(", ");
                            }
                            String title = currencyDO.getTitleZh();
                            DictDataRespDTO dictDataRespDTO = dictDataRespDTOMap.get(String.valueOf(feeDto.getFeeType()));
                            String feeTypeName = Objects.isNull(dictDataRespDTO) ? "未知费用" : dictDataRespDTO.getLabel();
                            sb.append(feeTypeName).append(" ")
                                    .append(feeDto.getAmount()).append(" ")
                                    .append(title);
                        }
                    }
                    excData.setEstCost(sb.toString());
                }
            }).collect(Collectors.toList());
            excelWriter.write(pageList, writeSheet);
            pageList.clear();
        }
//        pageReqVO.setPageNo(1);
//        pageReqVO.setPageSize(10000);
//        log.warn(I18nMessage.getLang().toString());
//        List<OfferRespVO> list = offerMapper.offerPage(pageReqVO, I18nMessage.getLang());
//        return new PageResult(list, total, mpPage.getSize(), pageReqVO.getPageNo() + 1, (total + mpPage.getSize() - 1) / mpPage.getSize());
        // 导出 Excel

//        ExcelUtils.write(response, "报价单管理.xls", "数据", OfferExcelVO.class, datas);
        // 千万别忘记finish 会帮忙关闭流
        excelWriter.finish();
        out.flush();
    }


    @Override
    public OfferRespVO getOfferByOrderId(Long orderId) {
        OfferDO offerDO = offerMapper.selectOne(new LambdaQueryWrapper<OfferDO>().eq(OfferDO::getOrderId, orderId).last("limit 1"));
        if (Objects.isNull(offerDO)) {
            return null;
        }
        OfferRespVO respVO = OfferConvert.INSTANCE.convert(offerDO);
        EstCostVO estCostVO = JSONObject.parseObject(offerDO.getEstCost(), EstCostVO.class);
        if (Objects.nonNull(estCostVO)) {
            List<FeeDto> feeDtoList = estCostVO.getFeeDtoList();
            if (CollectionUtil.isNotEmpty(feeDtoList)) {
                FeeDto feeDto = feeDtoList.stream().filter(dto -> Objects.equals(FeeTypeEnum.OTHER_FEE.getType(), dto.getFeeType())).findFirst().orElse(null);
                if (Objects.nonNull(feeDto)) {
                    respVO.setOtherFee(feeDto.getAmount());
                    respVO.setOtherFeeCurrencyId(feeDto.getCurrencyId());
                }
            }
        }
        OfferTransportDO offerTransportDO = offerTransportMapper.selectOne(new LambdaQueryWrapper<OfferTransportDO>().eq(OfferTransportDO::getOfferId, offerDO.getOfferId()).last("limit 1"));
        if (Objects.nonNull(offerTransportDO)) {
            respVO.setTransportVO(OfferTransportConvert.INSTANCE.convert(offerTransportDO));
        }
        List<OfferProdDO> offerProdDOList = offerProdMapper.selectList(new LambdaQueryWrapper<OfferProdDO>().eq(OfferProdDO::getOfferId, offerDO.getOfferId()).orderByAsc(OfferProdDO::getOfferProdId));
        if (CollectionUtil.isNotEmpty(offerProdDOList)) {
            respVO.setOfferProdRespVOList(OfferProdConvert.INSTANCE.convertList(offerProdDOList));
        }
        return respVO;
    }

    @Override
    public List<OfferRespVO> getOfferListByOrderId(Long orderId) {
        // 检查订单参数
        OrderDO orderDO = orderService.getById(orderId);
        if (Objects.isNull(orderDO)) {
            throw exception(ORDER_NOT_EXISTS);
        }
        OrderAssociationOfferQueryVO queryVO = new OrderAssociationOfferQueryVO();
        queryVO.setLineId(orderDO.getLineId());
        if (Objects.nonNull(orderDO.getChannelId()) && orderDO.getChannelId() > 0L) {
            queryVO.setChannelId(orderDO.getChannelId());
        }
        // 获取订单发货人与收货人信息
        // 发货人信息
        OrderConsignorDO orderConsignorDO = orderConsignorService.getOne(new LambdaQueryWrapper<OrderConsignorDO>().eq(OrderConsignorDO::getOrderId, orderId).orderByDesc(OrderConsignorDO::getId).last("limit 1"));
        if (Objects.isNull(orderConsignorDO) || Objects.isNull(orderConsignorDO.getCustomerContactsId()) || orderConsignorDO.getCustomerContactsId() == 0L) {
            // 订单发货人客户档案不存在则抛错
            throw exception(ORDER_CONSIGNOR_NOT_EXISTS);
        }
        queryVO.setConsignorId(orderConsignorDO.getCustomerContactsId());
        // 收货人信息
        OrderConsigneeDO orderConsigneeDO = orderConsigneeService.getOne(new LambdaQueryWrapper<OrderConsigneeDO>().eq(OrderConsigneeDO::getOrderId, orderId).orderByDesc(OrderConsigneeDO::getId).last("limit 1"));
        if (Objects.nonNull(orderConsigneeDO) && Objects.nonNull(orderConsigneeDO.getCustomerContactsId()) && orderConsigneeDO.getCustomerContactsId() > 0L) {
            queryVO.setConsigneeId(orderConsigneeDO.getCustomerContactsId());
        }
        return offerMapper.getOrderAssociationOfferList(queryVO, I18nMessage.getLang());
    }


    @Override
    public List<OfferRespVO> getOfferSelect(OrderAssociationOfferQueryVO queryVO) {
        // 获取订单发货人与收货人信息
        // 发货人信息
        if (Objects.isNull(queryVO.getConsignorId()) ||
                queryVO.getConsignorId() == 0) {
            // 客户端的发货人信息都是当前登录用户
            List<CustomerContactsDO> customerContactsDOList = null;
            if (queryVO.getUserType() == 1) {
                LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                customerContactsDOList = customerContactsService.getByMemberUserId(loginUser.getId());
                if (CollectionUtil.isEmpty(customerContactsDOList)) {
                    // 需要更新客户信息
                    UserRespDTO userRespDTO = memberUserApi.getUser(loginUser.getId());
                    customerContactsDOList = customerContactsService.getByPhone(userRespDTO.getAreaCode(), userRespDTO.getMobile());
                    // 当此客户端用户不存在绑定的有效客户信息时需要去关联创建
                    if (CollectionUtil.isEmpty(customerContactsDOList) || customerContactsDOList.size() == 0) {
                        customerApi.associateCustomerAuto(userRespDTO.getAreaCode(), userRespDTO.getMobile(), userRespDTO.getId(), userRespDTO.getNickname());
                        customerContactsDOList = customerContactsService.getByMemberUserId(loginUser.getId());
                    } else {
                        customerContactsService.update(new LambdaUpdateWrapper<CustomerContactsDO>()
                                .set(CustomerContactsDO::getUserid, userRespDTO.getId()).eq(CustomerContactsDO::getId, customerContactsDOList.get(0).getId()));
                    }
                }
            } else {
                customerContactsDOList = customerContactsService.getByPhone(queryVO.getConsignorCode(), queryVO.getConsignorPhone());
            }
            if (CollectionUtil.isEmpty(customerContactsDOList)) {
                // 订单发货人客户档案不存在则抛错
                throw exception(ORDER_CONSIGNOR_NOT_EXISTS);
            } else {
                queryVO.setConsignorId(customerContactsDOList.get(0).getId());
            }
        }
        // 收货人信息
        if (Objects.isNull(queryVO.getConsigneeId()) || queryVO.getConsigneeId() == 0) {
            List<CustomerContactsDO> customerContactsDOList = customerContactsService.getByPhone(queryVO.getConsigneeCode(), queryVO.getConsigneePhone());
//            if (CollectionUtil.isEmpty(customerContactsDOList)) {
//                if (queryVO.getUserType() == 2) {
//                    // 管理端查询时，订单收货人客户档案不存在则抛错，客户端忽略
//                    throw exception(ORDER_CONSIGNEE_NOT_EXISTS);
//                }
//            } else {
            if (CollectionUtil.isNotEmpty(customerContactsDOList) && customerContactsDOList.size() > 0) {
                queryVO.setConsigneeId(customerContactsDOList.get(0).getId());
            }
        }
        return offerMapper.getOrderAssociationOfferList(queryVO, I18nMessage.getLang());
    }

    @Override
    public void associationOfferAndOrder(Long offerId, Long orderId) {
        // 检查订单参数
        OrderDO orderDO = orderService.getById(orderId);
        if (Objects.isNull(orderDO)) {
            throw exception(ORDER_NOT_EXISTS);
        }
        OfferDO offerDO = offerMapper.selectById(offerId);
        if (Objects.isNull(offerDO)) {
            throw exception(OFFER_NOT_EXISTS);
        }
        if (Objects.nonNull(offerDO.getOrderId())) {
            if (!Objects.equals(offerDO.getOrderId(), orderId)) {
                throw exception(ORDER_ASSOCIATION_OFFER_NO_CAN_UPDATE);
            }
        }
        offerDO.setOrderId(orderId);
        offerDO.setOrderNo(orderDO.getOrderNo());
        offerMapper.updateById(offerDO);
    }

    @Override
    public EstCostVO getOfferCostByOrderId(Long orderId) {
        OfferDO offerDO = offerMapper.selectOne(new LambdaQueryWrapper<OfferDO>().eq(OfferDO::getOrderId, orderId).last("limit 1"));
        if (Objects.isNull(offerDO)) {
            return null;
        }
        return JSONObject.parseObject(offerDO.getEstCost(), EstCostVO.class);
    }
}
