package cn.iocoder.yudao.module.sale.vo.offer;

import cn.iocoder.yudao.module.sale.vo.offer.prod.OfferProdRespVO;
import cn.iocoder.yudao.module.sale.vo.offer.transport.OfferTransportCreateReqVO;
import cn.iocoder.yudao.module.sale.vo.offer.transport.OfferTransportRespVO;
import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.*;

import java.util.*;

import io.swagger.annotations.*;

@ApiModel("管理后台 - 报价单管理 Response VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class OfferRespVO extends OfferBaseVO {

    @ApiModelProperty(value = "主键ID", required = true)
    private Long offerId;

    @ApiModelProperty(value = "创建时间", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    @ApiModelProperty(value = "更新时间", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    @ApiModelProperty(value = "运输相关信息")
    private OfferTransportRespVO transportVO;

    @ApiModelProperty(value = "报价单商品列表")
    List<OfferProdRespVO> offerProdRespVOList;

    @ApiModelProperty(value = "始发地名称")
    private String departureName;

    @ApiModelProperty(value = "目的地名称")
    private String objectiveName;

    @ApiModelProperty(value = "关联客户名称")
    private String relationName;

    @ApiModelProperty(value = "业务员名称")
    private String creatorName;

    @ApiModelProperty(value = "跟进业务员")
    private String followUpSalesmanId;

}
